
package com.github.mikephil.charting.components;

import android.content.Context;
import android.widget.TextView;

import com.github.mikephil.charting.components.MarkerView;
import com.github.mikephil.charting.data.CandleEntry;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.Utils;
import com.github.mikephil.charting.components.R;


/**
 * Custom implementation of the MarkerView.
 * 
 * @author Philipp Jahoda
 */
public class MyMarkerView extends MarkerView {

    private TextView tvContent;

    //mFormat = new DecimalFormat("###,###,###,##0.0");                  //just copied here to see the way a format is set

    public MyMarkerView(Context context, int layoutResource) {
        super(context, layoutResource);

        tvContent = (TextView) findViewById(R.id.tvContent);
    }

    // callbacks everytime the MarkerView is redrawn, can be used to update the
    // content (user-interface)
    @Override
    public void refreshContent(Entry e, Highlight highlight) {

        if (e instanceof CandleEntry) {

            CandleEntry ce = (CandleEntry) e;

            tvContent.setText("" + Utils.formatNumber(ce.getHigh(), 0, true));
        } else {

            if (nod >= 0)
                tvContent.setText("" + Utils.formatNumber(e.getVal(), nod, true));
//            if (nod >= 1)
//                tvContent.setText("" + Utils.formatDecimal(e.getVal(), nod));                //changed by Johan to show two digits after decimal point in marker view - it was 0
        }
    }

    @Override
    public int getXOffset() {
        // this will center the marker-view horizontally
        return -(getWidth() / 2);
    }

    @Override
    public int getYOffset() {
        // this will cause the marker-view to be above the selected value
        return -getHeight();
    }

    //added by Johan Schoeman
    private int nod = 0; 
    public void setNumberOfDigits(int nod){
       this.nod = nod;
    }

}


