package mpandroidchartwrapper;

import com.github.mikephil.charting.charts.HorizontalBarChart;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;
import android.graphics.Color;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;
import android.graphics.Typeface;
//import mpandroidchartwrapper.R;

import java.util.ArrayList;

import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.Legend.LegendForm;
import com.github.mikephil.charting.components.Legend.LegendPosition;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.XAxis.XAxisPosition;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.components.YAxis.AxisDependency;
import com.github.mikephil.charting.components.YAxis.YAxisLabelPosition;
import com.github.mikephil.charting.data.BarData;
import com.github.mikephil.charting.data.BarDataSet;
import com.github.mikephil.charting.data.BarEntry;
import com.github.mikephil.charting.data.DataSet;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.filter.Approximator;
import com.github.mikephil.charting.data.filter.Approximator.ApproximatorType;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.ValueFormatter;
import com.github.mikephil.charting.utils.LargeValueFormatter;

import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.components.Legend.LegendDirection;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.utils.PercentFormatter;
import com.github.mikephil.charting.components.ComponentBase;
import com.github.mikephil.charting.components.MyMarkerView;
import com.github.mikephil.charting.components.R;
import com.github.mikephil.charting.utils.MyValueFormatter;




@Author("Johan Schoeman")
//@Version(1.00f)
@ShortName("HorizontalBarChart")
public class horizontalBarChartWrapper extends ViewWrapper<HorizontalBarChart> implements DesignerCustomView  {

        private Typeface tf;
        private Legend l;
        private ComponentBase cb;

	private BA ba;
	private String eventName;
        private HorizontalBarChart cv;

        private int[] barcolors = {Color.BLUE, Color.RED, Color.GREEN, Color.YELLOW, Color.CYAN};
        private String[] legendtext;
        private float[] chartdata;
        private int valcolor = 0xffff0000;
        private float valtextsize = 12.0f;
        private String legendtitle = "";
        private float shapesize = 5.0f;
        @Hide
        public static boolean usepercentval = true;

        private float mXaxisTextSize = 12.0f;
        private int mXaxisTextColor = Color.BLUE;
        private boolean mXaxisGridLines = true;
        private boolean mXaxisLine = true;
        private String mXaxisLabelPosition = "BOTTOM";

        private float mYaxisTextSize = 15.0f;
        private int mYaxisTextColor = Color.BLUE;
        private boolean mYaxisGridLines = true;
        private int markertouse = 4; 
        private boolean leftlabels = true;
        private boolean rightlabels = true; 
        private boolean xanimate = false;
        private boolean yanimate = true;
        private boolean xyanimate = false;
        private int animationtime = 0;
        private float yaxisLeftMinVal = 192837.0f;
        private float yaxisLeftMaxVal = 192837.0f;       
        private float yaxisRightMinVal = 192837.0f;
        private float yaxisRightMaxVal = 192837.0f;   
        private int lyalc = 0;
        private int ryalc = 0;   	
        private int mXaxisLabelsToSkip = 0;	
		private int displayvaluedigits = 1;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new HorizontalBarChart(ba.context);
//                mv = new MarkerView(ba.context);
                this.setObject(cv);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    public void setXAnimate(boolean xa) {
        xanimate = xa;
    }

    public void setYAnimate(boolean ya) {
        yanimate = ya;
    }

    public void setXYAnimate(boolean xya) {
        xyanimate = xya;
    }


    public void setChartAnimationTime(int at) {
        animationtime = at;
    }

    public void setBarData(int count) {
        count = count - 1;

//        mv = MarkerView(cv, R.layout.custom_marker_view);
//        cv.setMarkerView(mv);

        ArrayList<String> xVals = new ArrayList<String>();
        for (int i = 0; i < count+1; i++)
            xVals.add(legendtext[i]);

        ArrayList<BarEntry> yVals1 = new ArrayList<BarEntry>();

        for (int i = 0; i < count+1; i++) {
            yVals1.add(new BarEntry((float) chartdata[i], i));
        }

        if (markertouse == 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 3) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_3);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 2) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_2);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_1);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse > 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse < 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }

        BarDataSet set1 = new BarDataSet(yVals1, legendtitle);
        set1.setBarSpacePercent(35f);
        MyValueFormatter mvf1 = new MyValueFormatter();
        mvf1.setNumberOfDigits(displayvaluedigits);
        set1.setValueFormatter(mvf1);      		

        XAxis xAxis = cv.getXAxis();
//      xAxis.setTypeface(tf);
        xAxis.setTextSize(mXaxisTextSize);
        xAxis.setTextColor(mXaxisTextColor);
        xAxis.setDrawGridLines(mXaxisGridLines);
        if (mXaxisLabelsToSkip != 0) 
           xAxis.setLabelsToSkip(mXaxisLabelsToSkip);		
        xAxis.setDrawAxisLine(mXaxisLine);
//      xAxis.setSpaceBetweenLabels(1);
        if (mXaxisLabelPosition == "TOP") xAxis.setPosition(XAxisPosition.TOP);
        if (mXaxisLabelPosition == "BOTTOM") xAxis.setPosition(XAxisPosition.BOTTOM);
        if (mXaxisLabelPosition == "BOTH_SIDED") xAxis.setPosition(XAxisPosition.BOTH_SIDED);
        if (mXaxisLabelPosition == "TOP_INSIDE") xAxis.setPosition(XAxisPosition.TOP_INSIDE);
        if (mXaxisLabelPosition == "BOTTOM_INSIDE") xAxis.setPosition(XAxisPosition.BOTTOM_INSIDE);
 
        
        YAxis leftAxis = cv.getAxisLeft();
//        leftAxis.setTypeface(tf);
        leftAxis.setTextSize(mYaxisTextSize);
        leftAxis.setTextColor(mYaxisTextColor);
//        leftAxis.setAxisMaxValue(200f);
        leftAxis.setDrawGridLines(mYaxisGridLines);
        leftAxis.setEnabled(leftlabels);
		
        if (yaxisLeftMinVal != 192837.0f){
          leftAxis.setAxisMinValue(yaxisLeftMinVal);
        }
        if (yaxisLeftMaxVal != 192837.0f)
          leftAxis.setAxisMaxValue(yaxisLeftMaxVal);

          if (lyalc != 0) 
            leftAxis.setLabelCount(lyalc, true);	  
		
		MyValueFormatter lavf = new MyValueFormatter();
        lavf.setNumberOfDigits(YaxisLeftNumberOfDigits);
		leftAxis.setValueFormatter(lavf);

        leftAxis.setStartAtZero(lxsaz);		
        
          YAxis rightAxis = cv.getAxisRight();
//        rightAxis.setTypeface(tf);
          rightAxis.setTextSize(mYaxisTextSize);
          rightAxis.setTextColor(mYaxisTextColor);
//        rightAxis.setAxisMaxValue(900);
//        rightAxis.setStartAtZero(false);
//        rightAxis.setAxisMinValue(-200);
//        rightAxis.setDrawGridLines(false);
          rightAxis.setEnabled(rightlabels);
		  
        if (yaxisRightMinVal !=192837.0f)
          rightAxis.setAxisMinValue(yaxisRightMinVal);
        if (yaxisRightMaxVal !=192837.0f)
          rightAxis.setAxisMaxValue(yaxisRightMaxVal);

        if (ryalc != 0)
          rightAxis.setLabelCount(ryalc, true); 
	  
		  
		MyValueFormatter ravf = new MyValueFormatter();
        ravf.setNumberOfDigits(YaxisRightNumberOfDigits);
		rightAxis.setValueFormatter(ravf);	

        rightAxis.setStartAtZero(rxsaz);		

        if (xyanimate == true)
           cv.animateXY(animationtime, animationtime);
        if (xanimate == true)
           cv.animateX(animationtime);
        if (yanimate == true)
           cv.animateY(animationtime);


        ArrayList<Integer> colors = new ArrayList<Integer>();
        for (int i = 0; i < count+1 ; i++) {
           colors.add(barcolors[i]);
        }

        set1.setColors(colors);


        ArrayList<BarDataSet> dataSets = new ArrayList<BarDataSet>();
        dataSets.add(set1);

        BarData data = new BarData(xVals, dataSets);
        data.setValueTextSize(valtextsize);
        data.setValueTextColor(valcolor);
        data.setValueTypeface(tf);
        cv.setData(data);
        cv.invalidate();
    }


        public void setDrawBarShadow(boolean dbs){
          cv.setDrawBarShadow(dbs);
          cv.invalidate();
        }

        public void setDrawValueAboveBar(boolean dvab){
          cv.setDrawValueAboveBar(dvab);
          cv.invalidate();
        }

        public void setMaxVisibleValueCount(int mvvc){     //was set to 60 in example
          cv.setMaxVisibleValueCount(mvvc);
          cv.invalidate();
        }
		

    /**
     *Force the left y-axis to start at zero
     *mlc1.YaxisLeftStartAtZero = False ....(A)
     *mlc1.YaxisLeftMinVal = -1.0 ....(B)
     *mlc1.YaxisLeftMaxVal = 5.0 ....(C)	
     * 
     *If set to True then (B) will be ignored and the left y-axis will start at 0
     *If set to False then (B) and (C) will be adhered to
     *The default setting is False
     *If neither (A), (B), or (C) are used the scale will be set automatically
     */
    private boolean lxsaz = false;
    public void setYaxisLeftStartAtZero(boolean lxsaz) {
      this.lxsaz = lxsaz;
    }

    /**
     *Force the right y-axis to start at zero
     *mlc1.YaxisRightStartAtZero = False ....(A)
     *mlc1.YaxisRightMinVal = -1.0 ....(B)
     *mlc1.YaxisRightMaxVal = 5.0 ....(C)	
     * 
     *If set to True then (B) will be ignored and the right y-axis will start at 0
     *If set to False then (B) and (C) will be adhered to
     *The default setting is False
     *If neither (A), (B), or (C) are used the scale will be set automatically
     */
    private boolean rxsaz = false;
    public void setYaxisRightStartAtZero(boolean rxsaz) {
      this.rxsaz = rxsaz;
    }		
		
		
     private int NoOfMarkerDigits = 0;
    /**
     *set the number of insignificant digits to appear in the markers
     */
     public void setNoOfMarkerDigits(int NoOfMarkerDigits){
        this.NoOfMarkerDigits = NoOfMarkerDigits;
     }	


	      /**
     * Set the number of digits to display after the decimal point for the Left Y-axis
     */
      private int YaxisLeftNumberOfDigits = 1;
      public void setYaxisLeftNumberOfDigits(int YaxisLeftNumberOfDigits) {
		  this.YaxisLeftNumberOfDigits = YaxisLeftNumberOfDigits;
	  }
	  

     /**
     * Set the number of digits to display after the decimal point for the Right Y-axis
     */
      private int YaxisRightNumberOfDigits = 1;
      public void setYaxisRightNumberOfDigits(int YaxisRightNumberOfDigits) {
		  this.YaxisRightNumberOfDigits = YaxisRightNumberOfDigits;
	  }	 


    /**
     * Set the minimum value for the y axis (Left)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisLeftMinVal(float yamv) {
        yaxisLeftMinVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the maximum value for the y axis (Left)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisLeftMaxVal(float yamv) {
        yaxisLeftMaxVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the minimum value for the y axis (Right)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisRightMinVal(float yamv) {
        yaxisRightMinVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the maximum value for the y axis (Right)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisRightMaxVal(float yamv) {
        yaxisRightMaxVal = yamv;
        cv.invalidate();
    }
	
//    private int lyalc = 0;
    /**
     * Set the label count for the left Y Axis
     */
    public void setYaxisLeftLabelCount(int mlyalc){
        lyalc = mlyalc;
    }

//    private int ryalc = 0;
    /**
     * Set the label count for the right Y Axis
     */
    public void setYaxisRightLabelCount(int mryalc){
        ryalc = mryalc;
    }


    /**
     * Sets the number of labels that should be skipped on the axis before the
     * next label is drawn. This will disable the feature that automatically
     * calculates an adequate space between the axis labels and set the number
     * of labels to be skipped to the fixed number provided by this method. 
     * 
     */
    private void setXaxisLabelsToSkip(int sxalts) {
        mXaxisLabelsToSkip = sxalts;
    }

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
    public void setMarkerToUse(int mtu) {
        markertouse = mtu;
    }  

	    /**
     *set the number of insignificant digits to appear in the graph values
     */
    public void setGraphValueDigits(int displayvaluedigits){
       this.displayvaluedigits = displayvaluedigits;
    }
	

	
	
	
	  

	 

    /**
     * if set to true, both x and y axis can be scaled with 2 fingers, if false,
     * x and y axis can be scaled separately. default: false
     * 
     * @param enabled
     */
        public void setPinchZoom(boolean pz){     
          cv.setPinchZoom(pz);
          cv.invalidate();
        }

//        public void setDrawXLabels(boolean dxl){     
//          cv.setDrawXLabels(dxl);
//          cv.invalidate();
//        }


//        public void setDrawYLabels(boolean dyl){     
//          cv.setDrawYLabels(dyl);
//          cv.invalidate();
//        }


    public void setTheLegendPositionAndForm(String legendpos, String legendform) {
        l = cv.getLegend();
          if (legendpos == "RIGHT_OF_CHART")
                l.setPosition(LegendPosition.RIGHT_OF_CHART);
          if (legendpos == "RIGHT_OF_CHART_CENTER")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_CENTER);
          if (legendpos == "RIGHT_OF_CHART_INSIDE")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_INSIDE);
          if (legendpos == "LEFT_OF_CHART")       
                l.setPosition(LegendPosition.LEFT_OF_CHART);
          if (legendpos == "LEFT_OF_CHART_CENTER")       
                l.setPosition(LegendPosition.LEFT_OF_CHART_CENTER);
          if (legendpos == "LEFT_OF_CHART_INSIDE")        
                l.setPosition(LegendPosition.LEFT_OF_CHART_INSIDE);
          if (legendpos == "BELOW_CHART_LEFT")        
                l.setPosition(LegendPosition.BELOW_CHART_LEFT);
          if (legendpos == "BELOW_CHART_RIGHT")        
                l.setPosition(LegendPosition.BELOW_CHART_RIGHT);
          if (legendpos == "BELOW_CHART_CENTER")        
                l.setPosition(LegendPosition.BELOW_CHART_CENTER);

          if (legendform == "SQUARE") 
            l.setForm(LegendForm.SQUARE);
          if (legendform == "CIRCLE") 
            l.setForm(LegendForm.CIRCLE);
          if (legendform == "LINE") 
            l.setForm(LegendForm.LINE);

          l.setFormSize(shapesize);
          l.setXEntrySpace(0f);

        l.setYEntrySpace(10f);
//        l.setYOffset(0f);
    }

      public void setLegendShapeSize(float fsize){
           shapesize = fsize;
           cv.invalidate();
      }
	  
    /**
     * show or don't show the legend
     */
      public void setLegendVisible(boolean legendvisible){
           l.setEnabled(legendvisible);
           cv.invalidate();
      }      	  



//    public enum LegendDirection {
//        LEFT_TO_RIGHT, RIGHT_TO_LEFT
//    }




    public void setTheLegendColor(int lcolor) {
        l.setTextColor(lcolor);
    }

    public void setTheLegendTextSize(float ltextsize) {
        l.setTextSize(ltextsize);
    }

    public void setChartDescription(String descrip){
        cv.setDescription(descrip);
        cv.invalidate();
    }

    public void setChartDescriptionColor(int color){
        cv.setDescriptionColor(color);
        cv.invalidate();
    }

    public void setChartDescriptionTextSize(float size) {
        cv.setDescriptionTextSize(size);
        cv.invalidate();
    }

    public void setBarColors(int[] piecolor){
       barcolors = piecolor;
    }

    public void setLegendText(String[] ltext){
       legendtext = ltext;
    }

    public void setChartData(float[] cdata){
       chartdata = cdata;
    }

    public void setValueTextColor(int valuecolor){
      valcolor = valuecolor;
    }

    public void setValueTextSize(int vts){
      valtextsize = vts;
    }

    public void setLegendTitle(String lt){
      legendtitle = lt;
    }
 
    /**
     * Clears this data object from all DataSets and removes all Entries. Don't
     * forget to invalidate the chart after this.
     */
    public void clearValues() {
        cv.clearValues();
        cv.invalidate();
    }

	/**
	 * set this to true to draw the highlightning arrow
	 * 
	 * @param enabled
	 */
//	public void setDrawHighlightArrow(boolean enabled) {
//		cv.setDrawHighlightArrow(enabled);
//                cv.invalidate();
//	}

    /**
     * Sets the color for the background of the chart-drawing area (everything
     * behind the grid lines).
     * 
     * @param color
     */
    public void setGridBackgroundColor(int color) {
        cv.setGridBackgroundColor(color);
        cv.invalidate();
    }

    /**
     * Set this to true to enable dragging (moving the chart with the finger)
     * for the chart (this does not effect scaling).
     * 
     * @param enabled
     */
    public void setDragEnabled(boolean enabled) {
        cv.setDragEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable scaling (zooming in and out by gesture) for
     * the chart (this does not effect dragging) on both X- and Y-Axis.
     * 
     * @param enabled
     */
    public void setScaleEnabled(boolean enabled) {
        cv.setScaleEnabled(enabled);
        cv.invalidate();
    }

    public void setScaleXEnabled(boolean enabled) {
        cv.setScaleXEnabled(enabled);
        cv.invalidate();
    }

    public void setScaleYEnabled(boolean enabled) {
        cv.setScaleYEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable zooming in by double-tap on the chart.
     * Default: enabled
     * 
     * @param enabled
     */
    public void setDoubleTapToZoomEnabled(boolean enabled) {
        cv.setDoubleTapToZoomEnabled(enabled);
        cv.invalidate();
    }

    /**
     * set this to true to draw the grid background, false if not
     * 
     * @param enabled
     */
    public void setDrawGridBackground(boolean enabled) {
        cv.setDrawGridBackground(enabled);
        cv.invalidate();
    }

    /**
     * Sets drawing the borders rectangle to true. If this is enabled, there is
     * no point drawing the axis-lines of x- and y-axis.
     * 
     * @param enabled
     */
    public void setDrawBorders(boolean enabled) {
        cv.setDrawBorders(enabled);
        cv.invalidate();
    }

    /**
     * Sets the width of the border lines in dp.
     * 
     * @param width
     */
    public void setBorderWidth(float width) {
        cv.setBorderWidth(width);
        cv.invalidate();
    }

    /**
     * Sets the color of the chart border lines.
     * 
     * @param color
     */
    public void setBorderColor(int color) {
        cv.setBorderColor(color);
        cv.invalidate();
    }

    /**
     * Sets a custom position for the description text in pixels on the screen.
     * 
     * @param x - xcoordinate
     * @param y - ycoordinate
     */
    public void setDescriptionPosition(float x, float y) {
        cv.setDescriptionPosition(x, y);
        cv.invalidate();
    }

    /**
     * Set this to true to draw a user specified marker-view when tapping on
     * chart values (use the setMarkerView(MarkerView mv) method to specify a
     * marker view). Default: true
     *
     * @param enabled
     */
//    public void setDrawMarkerViews(boolean enabled) {
//        cv.setDrawMarkerViews(enabled);
//        cv.invalidate();
//    }

    /**
     * If set to true, value highlighting is enabled for all underlying data of
     * the chart which means that all values can be highlighted programmatically
     * or by touch gesture.
     *
     * @param enabled
     */
//    public void setHighlightEnabled(boolean enabled) {
//        cv.setHighlightEnabled(enabled);
//        cv.invalidate();
//    }

    /**
     * Sets extra offsets (around the chart view) to be appended to the
     * auto-calculated offsets.
     * 
     * @param left
     * @param top
     * @param right
     * @param bottom
     */
//    public void setExtraOffsets(float left, float top, float right, float bottom) {
//        cv.setExtraOffsets(left, top, right, bottom);
//        cv.invalidate();
//   }

    /**
     * Set an extra offset to be appended to the viewport's top
     */
//    public void setExtraTopOffset(float offset) {
//        cv.setExtraTopOffset(offset);
//        cv.invalidate();
//    }


    /**
     * Set an extra offset to be appended to the viewport's right
     */
//    public void setExtraRightOffset(float offset) {
//        cv.setExtraRightOffset(offset);
//        cv.invalidate();
//    }


    /**
     * Set an extra offset to be appended to the viewport's bottom
     */
//    public void setExtraBottomOffset(float offset) {
//        cv.setExtraBottomOffset(offset);
//        cv.invalidate();
//   }


    /**
     * Set an extra offset to be appended to the viewport's left
     */
//    public void setExtraLeftOffset(float offset) {
//        cv.setExtraLeftOffset(offset);
//        cv.invalidate();
//    }

    /**
     * disables intercept touchevents
     */
    public void disableScroll() {
        cv.disableScroll();
        cv.invalidate();
    }

    /**
     * enables intercept touchevents
     */
    public void enableScroll() {
        cv.enableScroll();
        cv.invalidate();
    }

    /**
     * set X-Axis text size
     */
    public void setXaxisTextSize(float size) {
        mXaxisTextSize = size;
    }    

    /**
     * set X-Axis text color
     */
    public void setXaxisTextColor(int xcolor) {
        mXaxisTextColor = xcolor;
    }    

    /**
     * set draw x-axis grid lines
     */
    public void setDrawXaxisGridLines(boolean dxagl) {
        mXaxisGridLines = dxagl;
    }    

    /**
     * set draw x-axis line
     */
    public void setDrawAxisLine(boolean dxal) {
        mXaxisLine = dxal;
    }    


    /**
     * set x-axis label position
     */
    public void setXaxisLabelPosition(String xalp){  
        mXaxisLabelPosition = xalp;
    }  

    /**
     * set Y-Axis text size
     */
    public void setYaxisTextSize(float size) {
        mYaxisTextSize = size;
    }    

    /**
     * set Y-Axis text color
     */
    public void setYaxisTextColor(int ycolor) {
        mYaxisTextColor = ycolor;
    }    

    /**
     * set draw y-axis grid lines
     */
    public void setDrawYaxisGridLines(boolean dyagl) {
        mYaxisGridLines = dyagl;
    } 

    /**
     * Show or don't show the left Y-Axis labels.
     */
    public void setShowYaxisLeftLabels(boolean slyal) {
        leftlabels = slyal;
    }    

    /**
     * Show or don't show the right Y-Axis labels.
     */
    public void setShowYaxisRightLabels(boolean sryal) {
        rightlabels = sryal;
    }   

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
//    public void setMarkerToUse(int mtu) {
//        markertouse = mtu;
//    }  




    /**
     * Saves the current state of the chart to the gallery as a JPEG image. The
     * filename and compression can be set. 0 == maximum compression, 100 = low
     * compression (high quality). NOTE: Needs permission WRITE_EXTERNAL_STORAGE
     *
     * fileName e.g. "my_image"
     * quality e.g. 50, min = 0, max = 100
     */
       public void saveToGallery(String fileName, int quality) {
            cv.saveToGallery(fileName, quality);
       }


    /**
     * Saves the current chart state with the given name to the given path on
     * the sdcard leaving the path empty "" will put the saved file directly on
     * the SD card chart is saved as a PNG image, example:
     * saveToPath("myfilename", "foldername1/foldername2");
     *
     * fileName e.g. "my_image"
     * pathOnSD e.g. "folder1/folder2/folder3"
     */
    public void saveToPath(String fileName, String pathOnSD) {
      cv.saveToPath(fileName, pathOnSD);
    }

    /**
     * Returns the bitmap that represents the chart.
     *
     * @return
     */
    public Bitmap getChartBitmap() {
        Bitmap image = cv.getChartBitmap(); 
//        byte[] byteArray = cv.getChartBitmap();
//        image = BitmapFactory.decodeByteArray(byteArray, 0, byteArray.length);     //added by johan schoeman
        BitmapWrapper bw = new BitmapWrapper();                                    //added by johan schoeman - Erel advised
        bw.setObject(image); 
        return image;
    }

    public void setSavedImageBackgroundColor(int color){
       cv.setSavedImageBackgroundColor(color);
    }
          


}
