package mpandroidchartwrapper;

import com.github.mikephil.charting.charts.CombinedChart;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;
import android.graphics.Color;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;
import android.graphics.Typeface;

import java.util.ArrayList;

import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.Legend.LegendForm;
import com.github.mikephil.charting.components.Legend.LegendPosition;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.XAxis.XAxisPosition;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.components.YAxis.AxisDependency;
import com.github.mikephil.charting.components.YAxis.YAxisLabelPosition;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.BarEntry;
import com.github.mikephil.charting.data.filter.Approximator;
import com.github.mikephil.charting.data.filter.Approximator.ApproximatorType;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.ValueFormatter;
import com.github.mikephil.charting.utils.LargeValueFormatter;

import com.github.mikephil.charting.components.Legend.LegendDirection;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.utils.PercentFormatter;
import com.github.mikephil.charting.components.ComponentBase;

import com.github.mikephil.charting.charts.CombinedChart.DrawOrder;
import com.github.mikephil.charting.data.CombinedData;
import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.charts.BarChart;
import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.LimitLine;
import com.github.mikephil.charting.components.LimitLine.LimitLabelPosition;
import com.github.mikephil.charting.data.DataSet;
import com.github.mikephil.charting.data.BarData;
import com.github.mikephil.charting.data.BarDataSet;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.data.LineDataSet;
import com.github.mikephil.charting.listener.OnChartGestureListener;
import com.github.mikephil.charting.components.MyMarkerView;
import com.github.mikephil.charting.components.R;
import com.github.mikephil.charting.utils.MyValueFormatter;

import com.github.mikephil.charting.data.BubbleData;
import com.github.mikephil.charting.data.BubbleDataSet;
import com.github.mikephil.charting.data.BubbleEntry;
import com.github.mikephil.charting.data.CandleData;
import com.github.mikephil.charting.data.CandleDataSet;
import com.github.mikephil.charting.data.CandleEntry;
import com.github.mikephil.charting.data.ScatterData;
import com.github.mikephil.charting.data.ScatterDataSet;



@Author("Johan Schoeman")
//@Version(1.00f)
@ShortName("MultiLineBarChart")
public class multiLineBarChartWrapper extends ViewWrapper<CombinedChart> implements DesignerCustomView  {

        private Typeface tf;
        private Legend l;
        private ComponentBase cb;

	private BA ba;
	private String eventName;
        private CombinedChart cv;
        private int barcolors = 0x640000ff;
        private int[] linecolors = {0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff};
        private String[] linelegendtext;
        private String barlegendtext;
        private int[] vallinecolor = {0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff};
        private int valbarcolor = 0x640000ff;
        private float barvaltextsize = 12.0f;
        private float linevaltextsize = 12.0f;
        private String legendtitle = "";
        private float shapesize = 5.0f;
        @Hide
        public static boolean usepercentval = true;

        private float mXaxisTextSize = 12.0f;
        private int mXaxisTextColor = Color.BLUE;
//      private boolean mXaxisGridLines = true;
        private boolean mXaxisLine = true;
        private String mXaxisLabelPosition = "BOTTOM";

        private float mYaxisTextSize = 15.0f;
        private int leftYaxisTextColor = Color.BLUE;
        private int rightYaxisTextColor = Color.RED;
        private boolean mYaxisGridLines = true;
        private boolean[] drawDashLine = {false, false, false, false, false, false, false, false, false, false}; 
        private int[] circlecolor = {0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff};
        private float[] graphlinewidth = {2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f};
        private float[] circlesize = {4.0f, 4.0f, 4.0f, 4.0f, 4.0f, 4.0f, 4.0f, 4.0f, 4.0f, 4.0f};
        private boolean[] circlehole = {false, false, false, false, false, false, false, false, false, false}; 
        private boolean drawbarvals = false;
        private boolean[] drawlinevals = {true, true, true, true, true, true, true, true, true, true};
        private boolean[] drawcubic = {false, false, false, false, false, false, false, false, false, false};
        private float[] cubicintensity = {0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f};
        private int crosscolor = 0xffff0000;
        private float yaxisMinVal = 192837.0f;
        private float yaxisMaxVal = 192837.0f;       
        private boolean[] drawfilled = {false, false, false, false, false, false, false, false, false, false}; 
        private int fillcolor[] = {0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff};
//      private boolean leftlabels = true;
//      private boolean rightlabels = true; 

//      private String[] mMonths = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

        private float[] line_1_data = null;
        private float[] line_2_data = null;
        private float[] line_3_data = null;
        private float[] line_4_data = null;
        private float[] line_5_data = null;
        private float[] line_6_data = null;
		private float[] line_7_data = null;
        private float[] line_8_data = null;
        private float[] line_9_data = null;
        private float[] line_10_data = null;		

        private float[] bar_data = null;


        private int markertouse = 4; 
//      private float legendspacing = 6.0f;
        private boolean xanimate = false;
        private boolean yanimate = true;
        private boolean xyanimate = false;
        private int animationtime = 0;
        private int itemcount = 12;
        private String lineAxisDependency = "LEFT";
        private String barAxisDependency = "LEFT";
        private float mAngle = 0.0f;
        
        private int numberoflinecharts = 1;
        private boolean drawbarchart = true;
        private int numberofentries = 5;


        private String[] xaxislabels = null;

        YAxis rightAxis;
        YAxis leftAxis;
        XAxis xAxis;

        private boolean mYaxisRightGridLines = false;
        private boolean mYaxisLeftGridLines = false;
        private boolean drawrightgriddashed = false;
        private boolean drawleftgriddashed = false;

        private int verticalgridcolor = Color.GRAY;
        private int horizontalgridcolorleft = Color.GRAY;
        private int horizontalgridcolorright = Color.GRAY;

        private float mYAngle = 0.0f;


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new CombinedChart(ba.context);
                this.setObject(cv);
//              addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}






    public void DrawCharts() {


//      cv.setBackgroundColor(setGridBackgroundColor);
        cv.setDrawGridBackground(false);
        cv.setDrawBarShadow(false);

        // draw bars behind lines
        cv.setDrawOrder(new DrawOrder[]{
                DrawOrder.BAR, DrawOrder.LINE
        });

        rightAxis = cv.getAxisRight();
//      rightAxis.setDrawGridLines(false);

        rightAxis.setDrawGridLines(mYaxisRightGridLines);
        if (drawrightgriddashed == true)
          rightAxis.enableGridDashedLine(10.0f, 10.0f, 0.0f);

        rightAxis.setGridColor(horizontalgridcolorright);
        rightAxis.setYaxisTextAngle(mYAngle);




        leftAxis = cv.getAxisLeft();
//      leftAxis.setDrawGridLines(false);

        leftAxis.setDrawGridLines(mYaxisLeftGridLines);
        if (drawleftgriddashed == true)
          leftAxis.enableGridDashedLine(10.0f, 10.0f, 0.0f);

        leftAxis.setGridColor(horizontalgridcolorleft);
        leftAxis.setYaxisTextAngle(mYAngle);

        if (xyanimate == true)
           cv.animateXY(animationtime, animationtime);
        if (xanimate == true)
           cv.animateX(animationtime);
        if (yanimate == true)
           cv.animateY(animationtime);

        CombinedData data = new CombinedData(xaxislabels);

        LineData mlineData = null;
        if (numberoflinecharts >= 1) 
           mlineData = generateLineData1();
        if (numberoflinecharts >= 2)
           mlineData.addDataSet(generateLineData2().getDataSetByIndex(0));
        if (numberoflinecharts >= 3)
           mlineData.addDataSet(generateLineData3().getDataSetByIndex(0));
        if (numberoflinecharts >= 4)
           mlineData.addDataSet(generateLineData4().getDataSetByIndex(0));
        if (numberoflinecharts >= 5)
           mlineData.addDataSet(generateLineData5().getDataSetByIndex(0));	   
        if (numberoflinecharts >= 6)
           mlineData.addDataSet(generateLineData6().getDataSetByIndex(0));	
        if (numberoflinecharts >= 7)
           mlineData.addDataSet(generateLineData7().getDataSetByIndex(0));	 
        if (numberoflinecharts >= 8)
           mlineData.addDataSet(generateLineData8().getDataSetByIndex(0));	
        if (numberoflinecharts >= 9)
           mlineData.addDataSet(generateLineData9().getDataSetByIndex(0));	   
        if (numberoflinecharts == 10)
           mlineData.addDataSet(generateLineData10().getDataSetByIndex(0));
	   
	   
	   
	   
	   

        data.setData(mlineData);


//      BarData mbarData = null;
//      mbarData = generateBarData1();
//      mbarData.addDataSet(generateBarData2().getDataSetByIndex(0));

//      data.setData(mbarData);


        if (drawbarchart == true)                         //original code
          data.setData(generateBarData1());               //original code
     

        
        cv.setData(data);                                 //original code
        cv.invalidate();
    }

    private LineData generateLineData1() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_1_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[0]);
        set.setColor(linecolors[0]);
        set.setLineWidth(graphlinewidth[0]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[0]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[0]);
        set.setHighLightColor(linecolors[0]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[0] == true) {
          set.setDrawCubic(drawcubic[0]);
          set.setCubicIntensity(cubicintensity[0]);
        }
        set.setDrawCircleHole(circlehole[0]);
        set.setCircleSize(circlesize[0]);
        set.setCircleColor(circlecolor[0]);    
        if (drawDashLine[0] == true) 
          set.enableDashedLine(10f, 10f, 0f);
   
        d.setValueFormatter(new MyValueFormatter());                       //added 31 Oct 2015
        d.addDataSet(set);

        return d;
    }

    private LineData generateLineData2() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_2_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[1]);
        set.setColor(linecolors[1]);
        set.setLineWidth(graphlinewidth[1]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[1]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[1]);
        set.setHighLightColor(linecolors[1]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[1] == true) {
          set.setDrawCubic(drawcubic[1]);
          set.setCubicIntensity(cubicintensity[1]);
        }
        set.setDrawCircleHole(circlehole[1]);
        set.setCircleSize(circlesize[1]);
        set.setCircleColor(circlecolor[1]); 
        if (drawDashLine[1] == true) 
          set.enableDashedLine(10f, 10f, 0f);
      

        d.addDataSet(set);

        return d;
    }

    private LineData generateLineData3() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_3_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[2]);
        set.setColor(linecolors[2]);
        set.setLineWidth(graphlinewidth[2]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[2]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[2]);
        set.setHighLightColor(linecolors[2]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[2] == true) {
          set.setDrawCubic(drawcubic[2]);
          set.setCubicIntensity(cubicintensity[2]);
        }
        set.setDrawCircleHole(circlehole[2]);
        set.setCircleSize(circlesize[2]);
        set.setCircleColor(circlecolor[2]);  
        if (drawDashLine[2] == true) 
          set.enableDashedLine(10f, 10f, 0f);
   

        d.addDataSet(set);

        return d;
    }

    private LineData generateLineData4() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_4_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[3]);
        set.setColor(linecolors[3]);
        set.setLineWidth(graphlinewidth[3]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[3]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[3]);
        set.setHighLightColor(linecolors[3]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[3] == true) {
          set.setDrawCubic(drawcubic[3]);
          set.setCubicIntensity(cubicintensity[3]);
        }
        set.setDrawCircleHole(circlehole[3]);
        set.setCircleSize(circlesize[3]);
        set.setCircleColor(circlecolor[3]);  
        if (drawDashLine[3] == true) 
          set.enableDashedLine(10f, 10f, 0f);
    

        d.addDataSet(set);

        return d;
    }

    private LineData generateLineData5() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_5_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[4]);
        set.setColor(linecolors[4]);
        set.setLineWidth(graphlinewidth[4]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[4]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[4]);
        set.setHighLightColor(linecolors[4]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[4] == true) {
          set.setDrawCubic(drawcubic[4]);
          set.setCubicIntensity(cubicintensity[4]);
        }
        set.setDrawCircleHole(circlehole[4]);
        set.setCircleSize(circlesize[4]);
        set.setCircleColor(circlecolor[4]); 
        if (drawDashLine[4] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }
	
	
    private LineData generateLineData6() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_6_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[5]);
        set.setColor(linecolors[5]);
        set.setLineWidth(graphlinewidth[5]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[5]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[5]);
        set.setHighLightColor(linecolors[5]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[5] == true) {
          set.setDrawCubic(drawcubic[5]);
          set.setCubicIntensity(cubicintensity[5]);
        }
        set.setDrawCircleHole(circlehole[5]);
        set.setCircleSize(circlesize[5]);
        set.setCircleColor(circlecolor[5]); 
        if (drawDashLine[5] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }
	


    private LineData generateLineData7() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_7_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[6]);
        set.setColor(linecolors[6]);
        set.setLineWidth(graphlinewidth[6]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[6]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[6]);
        set.setHighLightColor(linecolors[6]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[6] == true) {
          set.setDrawCubic(drawcubic[6]);
          set.setCubicIntensity(cubicintensity[6]);
        }
        set.setDrawCircleHole(circlehole[6]);
        set.setCircleSize(circlesize[6]);
        set.setCircleColor(circlecolor[6]); 
        if (drawDashLine[6] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }	
	
	
    private LineData generateLineData8() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_8_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[7]);
        set.setColor(linecolors[7]);
        set.setLineWidth(graphlinewidth[7]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[7]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[7]);
        set.setHighLightColor(linecolors[7]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[7] == true) {
          set.setDrawCubic(drawcubic[7]);
          set.setCubicIntensity(cubicintensity[7]);
        }
        set.setDrawCircleHole(circlehole[7]);
        set.setCircleSize(circlesize[7]);
        set.setCircleColor(circlecolor[7]); 
        if (drawDashLine[7] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }		
	
	
    private LineData generateLineData9() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_9_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[8]);
        set.setColor(linecolors[8]);
        set.setLineWidth(graphlinewidth[8]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[8]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[8]);
        set.setHighLightColor(linecolors[8]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[8] == true) {
          set.setDrawCubic(drawcubic[8]);
          set.setCubicIntensity(cubicintensity[8]);
        }
        set.setDrawCircleHole(circlehole[8]);
        set.setCircleSize(circlesize[8]);
        set.setCircleColor(circlecolor[8]); 
        if (drawDashLine[8] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }			

	
	
    private LineData generateLineData10() {

        LineData d = new LineData();

        ArrayList<Entry> entries = new ArrayList<Entry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new Entry(line_10_data[index], index));

        LineDataSet set = new LineDataSet(entries, linelegendtext[9]);
        set.setColor(linecolors[9]);
        set.setLineWidth(graphlinewidth[9]);
//        set.setCircleColor(Color.rgb(240, 238, 70));
//        set.setCircleSize(5f);
        // set.setFillColor(Color.rgb(240, 238, 70));
        set.setDrawValues(drawlinevals[9]);
        set.setValueTextSize(linevaltextsize);
        set.setValueTextColor(vallinecolor[9]);
        set.setHighLightColor(linecolors[9]);
        if (lineAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (lineAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        if (drawcubic[9] == true) {
          set.setDrawCubic(drawcubic[9]);
          set.setCubicIntensity(cubicintensity[9]);
        }
        set.setDrawCircleHole(circlehole[9]);
        set.setCircleSize(circlesize[9]);
        set.setCircleColor(circlecolor[9]); 
        if (drawDashLine[9] == true) 
          set.enableDashedLine(10f, 10f, 0f);
     

        d.addDataSet(set);

        return d;
    }			
	




    private BarData generateBarData1() {

        BarData d = new BarData();

        ArrayList<BarEntry> entries = new ArrayList<BarEntry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new BarEntry(bar_data[index], index));

        BarDataSet set = new BarDataSet(entries, barlegendtext);
        set.setColor(barcolors);
        set.setValueTextColor(valbarcolor);
        set.setValueTextSize(barvaltextsize);
        set.setHighLightColor(barcolors);
        set.setDrawValues(drawbarvals);
        d.addDataSet(set);

        if (barAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (barAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        return d;
    }

//    private float getRandom(float range, float startsfrom) {
//        return (float) (Math.random() * range) + startsfrom;
//    }

    private BarData generateBarData2() {

        BarData d = new BarData();

        ArrayList<BarEntry> entries = new ArrayList<BarEntry>();

        for (int index = 0; index < itemcount; index++)
            entries.add(new BarEntry(getRandom(40, 20),index));

        BarDataSet set = new BarDataSet(entries, barlegendtext);
        set.setColor(0xffff0000);
        set.setValueTextColor(valbarcolor);
        set.setValueTextSize(barvaltextsize);
        set.setHighLightColor(barcolors);
        set.setDrawValues(drawbarvals);
        d.addDataSet(set);

        if (barAxisDependency == "RIGHT") set.setAxisDependency(YAxis.AxisDependency.RIGHT);
        if (barAxisDependency == "LEFT") set.setAxisDependency(YAxis.AxisDependency.LEFT);
        return d;
    }




    private float getRandom(float range, float startsfrom) {
        return (float) (Math.random() * range) + startsfrom;
    }




//********************************************************************************************************************************************************




    public void setTheLegendPositionAndForm(String legendpos, String legendform) {
        l = cv.getLegend();
          if (legendpos == "RIGHT_OF_CHART")
                l.setPosition(LegendPosition.RIGHT_OF_CHART);
          if (legendpos == "RIGHT_OF_CHART_CENTER")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_CENTER);
          if (legendpos == "RIGHT_OF_CHART_INSIDE")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_INSIDE);
          if (legendpos == "LEFT_OF_CHART")       
                l.setPosition(LegendPosition.LEFT_OF_CHART);
          if (legendpos == "LEFT_OF_CHART_CENTER")       
                l.setPosition(LegendPosition.LEFT_OF_CHART_CENTER);
          if (legendpos == "LEFT_OF_CHART_INSIDE")        
                l.setPosition(LegendPosition.LEFT_OF_CHART_INSIDE);
          if (legendpos == "BELOW_CHART_LEFT")        
                l.setPosition(LegendPosition.BELOW_CHART_LEFT);
          if (legendpos == "BELOW_CHART_RIGHT")        
                l.setPosition(LegendPosition.BELOW_CHART_RIGHT);
          if (legendpos == "BELOW_CHART_CENTER")        
                l.setPosition(LegendPosition.BELOW_CHART_CENTER);

          if (legendform == "SQUARE") 
            l.setForm(LegendForm.SQUARE);
          if (legendform == "CIRCLE") 
            l.setForm(LegendForm.CIRCLE);
          if (legendform == "LINE") 
            l.setForm(LegendForm.LINE);

          l.setFormSize(shapesize);

          l.setYEntrySpace(10f);

    }

    public void setLegendShapeSize(float fsize){
         shapesize = fsize;
         cv.invalidate();
    }


    public void setTheLegendTextSize(float ltextsize) {
        l.setTextSize(ltextsize);
    }

    public void setChartDescription(String descrip){
        cv.setDescription(descrip);
        cv.invalidate();
    }

    public void setChartDescriptionColor(int color){
        cv.setDescriptionColor(color);
        cv.invalidate();
    }

    public void setChartDescriptionTextSize(float size) {
        cv.setDescriptionTextSize(size);
        cv.invalidate();
    }

        public void setMaxVisibleValueCount(int mvvc){     //was set to 60 in example
          cv.setMaxVisibleValueCount(mvvc);
          cv.invalidate();
        }

    /**
     * if set to true, both x and y axis can be scaled with 2 fingers, if false,
     * x and y axis can be scaled separately. default: false
     * 
     * @param enabled
     */
        public void setPinchZoom(boolean pz){     
          cv.setPinchZoom(pz);
          cv.invalidate();
        }


    /**
     * Sets the number of line charts that will be drawn (maximum 5)
     * 
     */
    public void setNumberOfLineCharts (int nolc){
      numberoflinecharts = nolc;

    }

    /**
     * Sets the angle to rotate the X-axis labels by
     * Suggest rotation of between -30.0 and 30.0 where 0.0 will be no rotation (i.e text horizontal)
     */
    public void setXaxisTextAngle(float angle){
        xAxis = cv.getXAxis();
        xAxis.setXaxisTextAngle(angle);
    }


    /**
     * Sets the number of entries per chart that will be drawn
     * Maximum number must be equal or less than the number of X-Axis labels that were set
     */
//    public void setNumberOfEntriesPerCharts (int nobc){
//      numberofbarcharts = nobc;
//    }


    /**
     * Sets the axis dependency for the Bar Chart
     * LEFT or RIGHT
     */
    public void setBarAxisDependency(String bad){
        barAxisDependency = bad;
    }

    /**
     * Sets the axis dependency for the Line Chart
     * LEFT or RIGHT
     */
    public void setLineAxisDependency(String lad){
        lineAxisDependency = lad;
    }

    /**
     * Sets the space between the legend entries on a horizontal axis in pixels,
     * converts to dp internally
     * Default value is 6.0f
     * @param space
     */
   public void setLegendEntrySpace(float space) {
       l = cv.getLegend();
       l.setXEntrySpace(space);
   }


    /**
     * Set the Y-Values for the Bar Chart
     * 
     */
    public void setBar_Data(float[] c1d){
        bar_data = c1d;
    }


    /**
     * Set the Y-Values for Line Chart 1
     * 
     */
    public void setLine_1_Data(float[] c1d){
        line_1_data = c1d;
    }

    /**
     * Set the Y-Values for Line Chart 2
     * 
     */
    public void setLine_2_Data(float[] c2d){
        line_2_data = c2d;
    }

    /**
     * Set the Y-Values for Line Chart 3
     * 
     */
    public void setLine_3_Data(float[] c3d){
        line_3_data = c3d;
    }

    /**
     * Set the Y-Values for Line Chart 4
     * 
     */
    public void setLine_4_Data(float[] c4d){
        line_4_data = c4d;
    }

    /**
     * Set the Y-Values for Line Chart 5
     * 
     */
    public void setLine_5_Data(float[] c5d){
        line_5_data = c5d;
    }
	
	
    /**
     * Set the Y-Values for Line Chart 6
     * 
     */
    public void setLine_6_Data(float[] c6d){
        line_6_data = c6d;
    }


    /**
     * Set the Y-Values for Line Chart 7
     * 
     */
    public void setLine_7_Data(float[] c7d){
        line_7_data = c7d;
    }


    /**
     * Set the Y-Values for Line Chart 8
     * 
     */
    public void setLine_8_Data(float[] c8d){
        line_8_data = c8d;
    }


    /**
     * Set the Y-Values for Line Chart 9
     * 
     */
    public void setLine_9_Data(float[] c9d){
        line_9_data = c9d;
    }


    /**
     * Set the Y-Values for Line Chart 10
     * 
     */
    public void setLine_10_Data(float[] c10d){
        line_10_data = c10d;
    }	

    /**
     * Set the X-Axis labels.
     */
    public void setXaxisLables(String[] xal) {
        xaxislabels = xal;
        cv.invalidate();
    } 

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
    public void setMarkerToUse(int mtu) {
        markertouse = mtu;


        if (markertouse == 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }
        if (markertouse == 3) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_3);
          cv.setMarkerView(mv);
        }
        if (markertouse == 2) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_2);
          cv.setMarkerView(mv);
        }
        if (markertouse == 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_1);
          cv.setMarkerView(mv);
        }
        if (markertouse > 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }
        if (markertouse < 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }
    }    

    /**
     * Show or don't show the right Y-Axis labels.
     */
    public void setShowYaxisRightLabels(boolean sryal) {
         rightAxis = cv.getAxisRight();
         rightAxis.setEnabled(sryal);
    }   

    /**
     * Show or don't show the left Y-Axis labels.
     */
    public void setShowYaxisLeftLabels(boolean slyal) {
         leftAxis = cv.getAxisLeft();
         leftAxis.setEnabled(slyal);
    }    

    /**
     * Set the maximum value for the y axis
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisMaxVal(float yamv) {
        yaxisMaxVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the minimum value for the y axis
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisMinVal(float yamv) {
        yaxisMinVal = yamv;
        cv.invalidate();
    }


    /**
     * Set the color of the cross hair that appears
     * when the graph is touched
     */
//    public void setCrossHairColor(int cc) {
//        crosscolor = cc;
//        cv.invalidate();
//    }

    /**
     * Set the intensity of the cubic line graph.
     * A value from 0.0 to 1.0
     */
    public void setCubicIntensity(float[] ci) {
        cubicintensity = ci;
    }


    /**
     * Draw or don't draw a cubic line graph.
     */
    public void setDrawCubicGraph(boolean[] dcg) {
        drawcubic = dcg;
    }

    /**
     * Draw or don't draw bar values on the graph.
     */
    public void setDrawBarValues(boolean dgv) {
        drawbarvals = dgv;
    }
         
    /**
     * Draw or don't draw line values on the graph.
     */
    public void setDrawLineValues(boolean[] dgv) {
        drawlinevals = dgv;
    }


    /**
     * Draw hollow or solid graph circles.
     */
    public void setDrawGraphHollowCircles(boolean[] ghc) {
        circlehole = ghc;
    }

    /**
     * Set the size of the graph small circles.
     */
    public void setGraphCircleSize(float[] gcs) {
        circlesize = gcs;
    }

    /**
     * Set the color of the graph small circles.
     */
    public void setGraphCircleColor(int[] gcc) {
        circlecolor = gcc;
    }



    /**
     * Set the width of the graph line.
     */
    public void setGraphLineWidth(float[] glw) {
        graphlinewidth = glw;
    }

    /**
     * Disables the line to be drawn in dashed mode.
     */
    public void setDrawDashedLine(boolean[] ddl) {
        drawDashLine = ddl;
    }

    /**
     * set draw y-axis grid lines
     */
//    public void setDrawYaxisGridLines(boolean dyagl) {
//        mYaxisGridLines = dyagl;
//        cv.invalidate();
//    }  




    /**
     * set the right Y-Axis text color
     */
    public void setRightYaxisTextColor(int rycolor) {
        rightAxis = cv.getAxisRight();
        rightAxis.setTextColor(rycolor);
    }    


    /**
     * set the left Y-Axis text color
     */
    public void setLeftYaxisTextColor(int lycolor) {
        leftAxis = cv.getAxisLeft();
        leftAxis.setTextColor(lycolor);
    }    

    /**
     * set left Y-Axis text size
     */
    public void setLeftYaxisTextSize(float size) {
        leftAxis = cv.getAxisLeft();
        leftAxis.setTextSize(size);
    }    

    /**
     * set right Y-Axis text size
     */
    public void setRightYaxisTextSize(float size) {
        rightAxis = cv.getAxisRight();
        rightAxis.setTextSize(size);
    }    





    /**
     * set x-axis label position
     */
    public void setXaxisLabelPosition(String xalp){  
        xAxis = cv.getXAxis();
        if (xalp == "TOP") xAxis.setPosition(XAxisPosition.TOP);
        if (xalp == "BOTTOM") xAxis.setPosition(XAxisPosition.BOTTOM);
        if (xalp == "BOTH_SIDED") xAxis.setPosition(XAxisPosition.BOTH_SIDED);
        if (xalp == "TOP_INSIDE") xAxis.setPosition(XAxisPosition.TOP_INSIDE);
        if (xalp == "BOTTOM_INSIDE") xAxis.setPosition(XAxisPosition.BOTTOM_INSIDE);
    }  

    /**
     * set draw x-axis line
     */
    public void setDrawAxisLine(boolean dxal) {
        mXaxisLine = dxal;
        cv.invalidate();
    }    

    /**
     * set draw x-axis grid lines (perpendicular to the X-axis)
     */
    public void setDrawXaxisGridLines(boolean dxagl) {
        xAxis = cv.getXAxis();
        xAxis.setDrawGridLines(dxagl);
    }    

    /**
     * set X-Axis text color
     */
    public void setXaxisTextColor(int xcolor) {
        xAxis = cv.getXAxis();
        xAxis.setTextColor(xcolor);
    }    

    /**
     * set X-Axis text size
     */
    public void setXaxisTextSize(float size) {
        xAxis = cv.getXAxis();
        xAxis.setTextSize(size);
    }    

    /**
     * enables intercept touchevents
     */
    public void enableScroll() {
        cv.enableScroll();
        cv.invalidate();
    }

    /**
     * disables intercept touchevents
     */
    public void disableScroll() {
        cv.disableScroll();
        cv.invalidate();
    }

    /**
     * If set to true, value highlighting is enabled for all underlying data of
     * the chart which means that all values can be highlighted programmatically
     * or by touch gesture.
     *
     * @param enabled
     */
//    public void setHighlightEnabled(boolean enabled) {
//        cv.setHighlightEnabled(enabled);
//        cv.invalidate();
//    }

    /**
     * Set this to true to draw a user specified marker-view when tapping on
     * chart values (use the setMarkerView(MarkerView mv) method to specify a
     * marker view). Default: true
     *
     * @param enabled
     */
    public void setDrawMarkerViews(boolean enabled) {
        cv.setDrawMarkerViews(enabled);
        cv.invalidate();
    }

    /**
     * Sets a custom position for the description text in pixels on the screen.
     * 
     * @param x - xcoordinate
     * @param y - ycoordinate
     */
    public void setDescriptionPosition(float x, float y) {
        cv.setDescriptionPosition(x, y);
        cv.invalidate();
    }

    /**
     * Sets drawing the borders rectangle to true. If this is enabled, there is
     * no point drawing the axis-lines of x- and y-axis.
     * 
     * @param enabled
     */
    public void setDrawBorders(boolean enabled) {
        cv.setDrawBorders(enabled);
        cv.invalidate();
    }

    /**
     * Sets the width of the border lines in dp.
     * 
     * @param width
     */
    public void setBorderWidth(float width) {
        cv.setBorderWidth(width);
        cv.invalidate();
    }

    /**
     * Sets the color of the chart border lines.
     * 
     * @param color
     */
    public void setBorderColor(int color) {
        cv.setBorderColor(color);
        cv.invalidate();
    }

    /**
     * Clears this data object from all DataSets and removes all Entries. Don't
     * forget to invalidate the chart after this.
     */
    public void clearValues() {
        cv.clearValues();
        cv.invalidate();
    }


    /**
     * Sets the color for the background of the chart-drawing area (everything
     * behind the grid lines).
     * 
     * @param color
     */
    public void setGridBackgroundColor(int color) {
        cv.setBackgroundColor(color);
        cv.invalidate();
    }

    /**
     * Set this to true to enable dragging (moving the chart with the finger)
     * for the chart (this does not effect scaling).
     * 
     * @param enabled
     */
    public void setDragEnabled(boolean enabled) {
        cv.setDragEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable scaling (zooming in and out by gesture) for
     * the chart (this does not effect dragging) on both X- and Y-Axis.
     * 
     * @param enabled
     */
    public void setScaleEnabled(boolean enabled) {
        cv.setScaleEnabled(enabled);
        cv.invalidate();
    }

    public void setScaleXEnabled(boolean enabled) {
        cv.setScaleXEnabled(enabled);
        cv.invalidate();
    }

    public void setScaleYEnabled(boolean enabled) {
        cv.setScaleYEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable zooming in by double-tap on the chart.
     * Default: enabled
     * 
     * @param enabled
     */
    public void setDoubleTapToZoomEnabled(boolean enabled) {
        cv.setDoubleTapToZoomEnabled(enabled);
        cv.invalidate();
    }

    /**
     * set this to true to draw the grid background, false if not
     * 
     * @param enabled
     */
//    public void setDrawGridBackground(boolean enabled) {
//        cv.setDrawGridBackground(enabled);
//        cv.invalidate();
//   }

    public void setXAnimate(boolean xa) {
        xanimate = xa;
    }

    public void setYAnimate(boolean ya) {
        yanimate = ya;
    }

    public void setXYAnimate(boolean xya) {
        xyanimate = xya;
    }


    public void setChartAnimationTime(int at) {
        animationtime = at;
    }


    public void setBarColor(int barcolor){
       barcolors = barcolor;
    }

    public void setLineColor(int[] linecolor){
       linecolors = linecolor;
    }

    public void setLineLegendText(String[] ltext){
       linelegendtext = ltext;
    }

    public void setBarLegendText(String btext){
       barlegendtext = btext;
    }

    public void setTheLegendTextColor(int lcolor) {
        l.setTextColor(lcolor);
    }


    public void setBarValueTextColor(int valuecolor){
      valbarcolor = valuecolor;
    }

    public void setLineValueTextColor(int[] valuecolor){
      vallinecolor = valuecolor;
    }

    public void setBarValueTextSize(float vts){
      barvaltextsize = vts;
    }

    public void setLineValueTextSize(float vts){
      linevaltextsize = vts;
    }

//    public void setLegendTitle(String lt){
//      legendtitle = lt;
//    }

    /**
     * Fill or don't fill the area between the graph and the X axis.
     */
//    public void setDrawFilled(boolean[] df) {
//        drawfilled = df;
//    }

    /**
     * Set the color to fill the area between the graph and the X axis with.
     */
//    public void setFillColor(int[] fc) {
//        fillcolor = fc;
//    }


    /**
     * Sets the number of bar charts that will be drawn (maximum 5)
     * 
     */
    public void setDrawBarChart (boolean dbc){
      drawbarchart = dbc;

    }

    /**
     * set draw y-axis left grid lines
     */
    public void setDrawYaxisLeftGridLines(boolean dyagl) {
        mYaxisLeftGridLines = dyagl;
        cv.invalidate();
    }  

    
    /**
     * set draw y-axis right grid lines
     */
    public void setDrawYaxisRightGridLines(boolean dyagl) {
        mYaxisRightGridLines = dyagl;
        cv.invalidate();
    } 

    /**
     * Sets the Left Y axis grid to be drawn dashed or solid
     */
    public void setDrawLeftGridDashed(boolean dlgd){
        drawleftgriddashed = dlgd;
    }

    /**
     * Sets the Right Y axis grid to be drawn dashed or solid
     */
    public void setDrawRightGridDashed(boolean drgd){
        drawrightgriddashed = drgd;
    } 

    /**
     * Sets the Horizontal grid color for the Left Y axis
     */
    public void setHorizontalGridColorLeft(int hgcl){
        horizontalgridcolorleft = hgcl;
    }

    /**
     * Sets the Horizontal grid color for the Right Y axis
     */
    public void setHorizontalGridColorRight(int hgcr){
        horizontalgridcolorright = hgcr;
    }

    /**
     * Sets the Vertical grid color
     */
    public void setVerticalGridColor(int vgc){
        xAxis = cv.getXAxis();
        xAxis.setGridColor(vgc);
    }

    /**
     * Sets the angle to rotate the Y-axis labels by
     * Suggest rotation of between -30.0 and 30.0 where 0.0 will be no rotation (i.e text horizontal)
     */
    public void setYaxisTextAngle(float angle){
        mYAngle = angle;
    }

    /**
     * Saves the current state of the chart to the gallery as a JPEG image. The
     * filename and compression can be set. 0 == maximum compression, 100 = low
     * compression (high quality). NOTE: Needs permission WRITE_EXTERNAL_STORAGE
     *
     * fileName e.g. "my_image"
     * quality e.g. 50, min = 0, max = 100
     */
       public void saveToGallery(String fileName, int quality) {
            cv.saveToGallery(fileName, quality);
       }


    /**
     * Saves the current chart state with the given name to the given path on
     * the sdcard leaving the path empty "" will put the saved file directly on
     * the SD card chart is saved as a PNG image, example:
     * saveToPath("myfilename", "foldername1/foldername2");
     *
     * fileName e.g. "my_image"
     * pathOnSD e.g. "folder1/folder2/folder3"
     */
    public void saveToPath(String fileName, String pathOnSD) {
      cv.saveToPath(fileName, pathOnSD);
    }

    /**
     * Returns the bitmap that represents the chart.
     *
     * @return
     */
    public Bitmap getChartBitmap() {
        Bitmap image = cv.getChartBitmap(); 
        BitmapWrapper bw = new BitmapWrapper();                                    
        bw.setObject(image); 
        return image;
    }

    public void setSavedImageBackgroundColor(int color){
       cv.setSavedImageBackgroundColor(color);
    }


}
