package mpandroidchartwrapper;

import com.github.mikephil.charting.charts.LineChart;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;
import android.graphics.Color;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;
import android.graphics.Typeface;

import java.util.ArrayList;
import java.text.DecimalFormat;

import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.Legend.LegendForm;
import com.github.mikephil.charting.components.Legend.LegendPosition;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.XAxis.XAxisPosition;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.components.YAxis.AxisDependency;
import com.github.mikephil.charting.components.YAxis.YAxisLabelPosition;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.filter.Approximator;
import com.github.mikephil.charting.data.filter.Approximator.ApproximatorType;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.ValueFormatter;
import com.github.mikephil.charting.utils.LargeValueFormatter;

import com.github.mikephil.charting.components.Legend.LegendDirection;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.utils.PercentFormatter;
import com.github.mikephil.charting.components.ComponentBase;

import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.LimitLine;
import com.github.mikephil.charting.components.LimitLine.LimitLabelPosition;
import com.github.mikephil.charting.data.DataSet;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.data.LineDataSet;
import com.github.mikephil.charting.listener.OnChartGestureListener;
import com.github.mikephil.charting.components.MyMarkerView;
import com.github.mikephil.charting.components.R;
import com.github.mikephil.charting.utils.MyValueFormatter;



@Author("Johan Schoeman")
@Version(1.06f)
@ShortName("MultiLineChart")
@Events(values={"value_selected(index As Int, value As Float)"})
public class multiLineChartWrapper extends ViewWrapper<LineChart> implements DesignerCustomView, OnChartValueSelectedListener  {

        private Typeface tf;
        private Legend l;
        private ComponentBase cb;

	private BA ba;
	private String eventName;
        private LineChart cv;
        private int[] linecolors = {Color.BLUE, Color.RED, Color.GREEN, Color.YELLOW, Color.CYAN, Color.BLUE, Color.RED, Color.GREEN, Color.YELLOW, Color.CYAN};
        private String[] legendtext;
        private float[] chartdata;
        private int[] valcolor = {0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000, 0xffff0000};
        private float[] valtextsize = {12.0f, 12.0f, 12.0f, 12.0f, 12.0f, 12.0f, 12.0f, 12.0f, 12.0f, 12.0f};
        private String legendtitle = "";
        private float shapesize = 5.0f;
        @Hide
        public static boolean usepercentval = true;

        private float mXaxisTextSize = 12.0f;
        private int mXaxisTextColor = Color.BLUE;
        private boolean mXaxisGridLines = true;
        private boolean mXaxisLine = true;
        private String mXaxisLabelPosition = "BOTTOM";

        private float mYaxisTextSize = 15.0f;
        private int mYaxisLeftTextColor = Color.BLUE;
        private int mYaxisRightTextColor = Color.BLUE;
        private boolean mYaxisLeftGridLines = true;
        private boolean mYaxisRightGridLines = true;
        private boolean[] drawDashLine = {true, true, true, true, true, true, true, true, true, true}; 
        private int[] circlecolor = {Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE};
        private float[] graphlinewidth = {2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f};
        private float[] circlesize = {2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f};
        private boolean[] circlehole = {false, false, false, false, false, false, false, false, false, false}; 
        private boolean[] drawvals = {false, false, false, false, false, false, false, false, false, false}; 
        private boolean[] drawcubic = {false, false, false, false, false, false, false, false, false, false}; 
        private float[] cubicintensity = {0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f, 0.2f};
        private int crosscolor = 0xffff0000;
        private float yaxisLeftMinVal = 192837.0f;
        private float yaxisLeftMaxVal = 192837.0f;       
        private float yaxisRightMinVal = 192837.0f;
        private float yaxisRightMaxVal = 192837.0f;       
        private boolean[] drawfilled = {false, false, false, false, false, false, false, false, false, false}; 
        private int fillcolor[] = {0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff, 0x640000ff};
        private boolean leftlabels = true;
        private boolean rightlabels = true; 
        private int[] displayvaluedigits = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

        private float[] chart_1_data = null;
        private float[] chart_2_data = null;
        private float[] chart_3_data = null;
        private float[] chart_4_data = null;
        private float[] chart_5_data = null; 
        private float[] chart_6_data = null; 
        private float[] chart_7_data = null; 
        private float[] chart_8_data = null; 
        private float[] chart_9_data = null; 
        private float[] chart_10_data = null; 		
        private int markertouse = 4; 
        private float legendxspacing = 6.0f;
        private float legendyspacing = 10.0f;
        private boolean xanimate = false;
        private boolean yanimate = true;
        private boolean xyanimate = false;
        private int animationtime = 0;

        private float mAngle = 0.0f;
        private float mYAngle = 0.0f;

        private String[] lineAxisDependency = {"LEFT", "LEFT", "LEFT", "LEFT", "LEFT","LEFT", "LEFT", "LEFT", "LEFT", "LEFT" };

        private int verticalgridcolor = Color.GRAY;
        private int horizontalgridcolorleft = Color.GRAY;
        private int horizontalgridcolorright = Color.GRAY;

        private int[] graphcolor = {Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE, Color.BLUE};

        private String[] xaxislabels = null;

        private boolean drawrightgriddashed = false;
        private boolean drawleftgriddashed = false;

        private int lyalc = 0;
        private int ryalc = 0;
        private int mXaxisLabelsToSkip = 0;

        private DecimalFormat mFormat0 = new DecimalFormat("###,###,###,##0");
        private DecimalFormat mFormat1 = new DecimalFormat("###,###,###,##0.0");
        private DecimalFormat mFormat2 = new DecimalFormat("###,###,###,##0.00");
        private DecimalFormat mFormat3 = new DecimalFormat("###,###,###,##0.000");
        private DecimalFormat mFormat4 = new DecimalFormat("###,###,###,##0.0000");    
 
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new LineChart(ba.context);
        this.setObject(cv);
		cv.setOnChartValueSelectedListener(this);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


        public void setMaxVisibleValueCount(int mvvc){     //was set to 60 in example
          cv.setMaxVisibleValueCount(mvvc);
          cv.invalidate();
        }

    /**
     * if set to true, both x and y axis can be scaled with 2 fingers, if false,
     * x and y axis can be scaled separately. default: false
     * 
     */
        public void setPinchZoom(boolean pz){     
          cv.setPinchZoom(pz);
          cv.invalidate();
        }

//        public void setDrawXLabels(boolean dxl){     
//          cv.setDrawXLabels(dxl);
//          cv.invalidate();
//        }


//        public void setDrawYLabels(boolean dyl){     
//          cv.setDrawYLabels(dyl);
//          cv.invalidate();
//        }

    /**
     * Set the legend Position and Form
     * Position can be one of the following:
     * "RIGHT_OF_CHART", "RIGHT_OF_CHART_CENTER", "RIGHT_OF_CHART_INSIDE", 
     * "LEFT_OF_CHART", "LEFT_OF_CHART_CENTER", "LEFT_OF_CHART_INSIDE",
     * "BELOW_CHART_LEFT", "BELOW_CHART_RIGHT", "BELOW_CHART_CENTER".
     * Form can be one of the following:
     * "SQUARE", "CIRCLE", "LINE"
     */
    public void setTheLegendPositionAndForm(String legendpos, String legendform) {
        l = cv.getLegend();
          if (legendpos == "RIGHT_OF_CHART")
                l.setPosition(LegendPosition.RIGHT_OF_CHART);
          if (legendpos == "RIGHT_OF_CHART_CENTER")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_CENTER);
          if (legendpos == "RIGHT_OF_CHART_INSIDE")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_INSIDE);
          if (legendpos == "LEFT_OF_CHART")       
                l.setPosition(LegendPosition.LEFT_OF_CHART);
          if (legendpos == "LEFT_OF_CHART_CENTER")       
                l.setPosition(LegendPosition.LEFT_OF_CHART_CENTER);
          if (legendpos == "LEFT_OF_CHART_INSIDE")        
                l.setPosition(LegendPosition.LEFT_OF_CHART_INSIDE);
          if (legendpos == "BELOW_CHART_LEFT")        
                l.setPosition(LegendPosition.BELOW_CHART_LEFT);
          if (legendpos == "BELOW_CHART_RIGHT")        
                l.setPosition(LegendPosition.BELOW_CHART_RIGHT);
          if (legendpos == "BELOW_CHART_CENTER")        
                l.setPosition(LegendPosition.BELOW_CHART_CENTER);

          if (legendform == "SQUARE") 
            l.setForm(LegendForm.SQUARE);
          if (legendform == "CIRCLE") 
            l.setForm(LegendForm.CIRCLE);
          if (legendform == "LINE") 
            l.setForm(LegendForm.LINE);

          l.setFormSize(shapesize);
//		  l.setEnabled(false);
//          l.setXEntrySpace(legendxspacing);
//        l.setXEntrySpace(25.0f);
//          l.setYEntrySpace(legendyspacing);
//        l.setYEntrySpace(25.0f);


    }

    /**
     * set the size of the legend SQUARE, CIRCLE, or LINE
     */
      public void setLegendShapeSize(float fsize){
           shapesize = fsize;
           cv.invalidate();
      }
	  
    /**
     * show or don't show the legend
     */
      public void setLegendVisible(boolean legendvisible){
           l.setEnabled(legendvisible);
           cv.invalidate();
      }      
	  

    /**
     * Draw the line chart(s) once all data has been set up
     * Mamimum number of simultaneous line charts is 5
     * variable numberOfCharts:
     * 1 = draw only the first line chart of all line charts that data has been set up for
     * 2 = draw only line charts 1 and 2 of all line charts that data has been set up for
     * 3 = draw only line charts 1, 2, and 3 of all line charts that data has been set up for
     *
     * numberOfEntriesPerChart:
     * draw only the first x number of entries for each line chart that data has been set up for
     * eg if data are passed for months of Jan to Dec and numberOfEntriesPerChart = 6
     * then each line chart will be drawn showing only data for Jan to Jun
     */
    public void setLineData(int numberOfCharts, int numberOfEntriesPerChart) {

        //This code was added to accomodate the number of legends to dispaly in class LegendRenderer when custom legend text colors
        //are required. See protected void drawLabel in class LegendRenderer
        if (LegendTextColorsToMatchLineColors == true) {
           l = cv.getLegend();
           if (numberOfCharts == 1) {
             int linecol[] = {linecolors[0]};
             String lines[] = {legendtext[0]};
             l.setCustom(linecol, lines);
           }
           if (numberOfCharts == 2) {
             int linecol[] = {linecolors[0], linecolors[1]};
             String lines[] = {legendtext[0], legendtext[1]};
             l.setCustom(linecol, lines);
           }
           if (numberOfCharts == 3) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2]};
             l.setCustom(linecol, lines);
           }
           if (numberOfCharts == 4) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3]};
             l.setCustom(linecol, lines);
           }
           if (numberOfCharts == 5) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4]};
             l.setCustom(linecol, lines);
           }
           if (numberOfCharts == 6) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4], linecolors[5]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4], legendtext[5]};
             l.setCustom(linecol, lines);
           }	
           if (numberOfCharts == 7) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4], linecolors[5], linecolors[6]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4], legendtext[5], legendtext[6]};
             l.setCustom(linecol, lines);
           }		   
           if (numberOfCharts == 8) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4], linecolors[5], linecolors[6], linecolors[7]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4], legendtext[5], legendtext[6], legendtext[7]};
             l.setCustom(linecol, lines);
           }	
           if (numberOfCharts == 9) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4], linecolors[5], linecolors[6], linecolors[7], linecolors[8]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4], legendtext[5], legendtext[6], legendtext[7], legendtext[8]};
             l.setCustom(linecol, lines);
           }				   
           if (numberOfCharts == 10) {
             int linecol[] = {linecolors[0], linecolors[1], linecolors[2], linecolors[3], linecolors[4], linecolors[5], linecolors[6], linecolors[7], linecolors[8], linecolors[9]};
             String lines[] = {legendtext[0], legendtext[1], legendtext[2], legendtext[3], legendtext[4], legendtext[5], legendtext[6], legendtext[7], legendtext[8], legendtext[9]};
             l.setCustom(linecol, lines);
           }	
        }

        ArrayList<Entry> yVals1 = new ArrayList<Entry>();
        ArrayList<Entry> yVals2 = new ArrayList<Entry>();
        ArrayList<Entry> yVals3 = new ArrayList<Entry>();
        ArrayList<Entry> yVals4 = new ArrayList<Entry>();
        ArrayList<Entry> yVals5 = new ArrayList<Entry>();
        ArrayList<Entry> yVals6 = new ArrayList<Entry>();
        ArrayList<Entry> yVals7 = new ArrayList<Entry>();
        ArrayList<Entry> yVals8 = new ArrayList<Entry>();
        ArrayList<Entry> yVals9 = new ArrayList<Entry>();
        ArrayList<Entry> yVals10 = new ArrayList<Entry>();		

          
        if (numberOfCharts >= 1){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals1.add(new Entry(chart_1_data[i], i));
          }
        }

        if (numberOfCharts >= 2){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals2.add(new Entry(chart_2_data[i], i));
          }
        }

        if (numberOfCharts >= 3){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals3.add(new Entry(chart_3_data[i], i));
          }
        }

        if (numberOfCharts >= 4){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals4.add(new Entry(chart_4_data[i], i));
          }
        }
		
        if (numberOfCharts >= 5){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals5.add(new Entry(chart_5_data[i], i));
          }
        }

        if (numberOfCharts >= 6){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals6.add(new Entry(chart_6_data[i], i));
          }
        }

        if (numberOfCharts >= 7){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals7.add(new Entry(chart_7_data[i], i));
          }
        }

        if (numberOfCharts >= 8){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals8.add(new Entry(chart_8_data[i], i));
          }
        }

        if (numberOfCharts >= 9){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals9.add(new Entry(chart_9_data[i], i));
          }
        }

        if (numberOfCharts == 10){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals10.add(new Entry(chart_10_data[i], i));
          }
        }

        ArrayList<String> xVals = new ArrayList<String>();

        for (int i = 0; i < numberOfEntriesPerChart; i++)
            xVals.add(xaxislabels[i]);


        if (markertouse == 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 3) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_3);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 2) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_2);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_1);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse > 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse < 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }


        ArrayList<LineDataSet> sets = new ArrayList<LineDataSet>();

        if (numberOfCharts >= 1){
          LineDataSet set1 = new LineDataSet(yVals1, legendtext[0]);
            if (numberOfCharts >= 1){
              set1.enableDashedLine(10f, 10f, 0f);
              set1.setColor(linecolors[0]);
              set1.setDrawFilled(drawfilled[0]);
              if (drawfilled[0] == true)
                   set1.setFillColor(fillcolor[0]);
              set1.setLineWidth(graphlinewidth[0]);
              set1.setHighLightColor(linecolors[0]);                   //the color of the cross hair
              set1.setDrawValues(drawvals[0]);
              set1.setValueTextSize(valtextsize[0]);
              set1.setValueTextColor(valcolor[0]);
              set1.setCircleColor(circlecolor[0]);       
              set1.setCircleSize(circlesize[0]);
              set1.setDrawCircleHole(circlehole[0]);
              MyValueFormatter mvf1 = new MyValueFormatter();
              mvf1.setNumberOfDigits(displayvaluedigits[0]);
              set1.setValueFormatter(mvf1);      
              if (drawcubic[0] == true) {
                set1.setDrawCubic(drawcubic[0]);
                set1.setCubicIntensity(cubicintensity[0]);
              }
            }
          if (lineAxisDependency[0] == "RIGHT") set1.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[0] == "LEFT") set1.setAxisDependency(YAxis.AxisDependency.LEFT);      
            sets.add(set1);
            if (drawDashLine[0] == false) 
               sets.get(0).disableDashedLine(); 
        }


        if (numberOfCharts >= 2){
          LineDataSet set2 = new LineDataSet(yVals2, legendtext[1]);
          if (numberOfCharts >= 2){
            set2.enableDashedLine(10f, 10f, 0f);
            set2.setColor(linecolors[1]);
            set2.setDrawFilled(drawfilled[1]);
            if (drawfilled[1] == true)
                   set2.setFillColor(fillcolor[1]);
            set2.setLineWidth(graphlinewidth[1]);
            set2.setHighLightColor(linecolors[1]);                   //the color of the cross hair
            set2.setDrawValues(drawvals[1]);
            set2.setValueTextSize(valtextsize[1]);
            set2.setValueTextColor(valcolor[1]);
            set2.setCircleColor(circlecolor[1]);       
            set2.setCircleSize(circlesize[1]);
            set2.setDrawCircleHole(circlehole[1]);
            MyValueFormatter mvf2 = new MyValueFormatter();
            mvf2.setNumberOfDigits(displayvaluedigits[1]);
            set2.setValueFormatter(mvf2);      
            if (drawcubic[1] == true) {
              set2.setDrawCubic(drawcubic[1]);
              set2.setCubicIntensity(cubicintensity[1]);
//            set2.setFillColor(fillcolor[1]);
            }
          }
          if (lineAxisDependency[1] == "RIGHT") set2.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[1] == "LEFT") set2.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set2);
          if (drawDashLine[1] == false) 
            sets.get(1).disableDashedLine(); 
        } 


        if (numberOfCharts >= 3){
          LineDataSet set3 = new LineDataSet(yVals3, legendtext[2]);
          if (numberOfCharts >= 3){
            set3.enableDashedLine(10f, 10f, 0f);
            set3.setColor(linecolors[2]);
            set3.setDrawFilled(drawfilled[2]);
            if (drawfilled[2] == true)
                 set3.setFillColor(fillcolor[2]);
            set3.setLineWidth(graphlinewidth[2]);
            set3.setHighLightColor(linecolors[2]);                   //the color of the cross hair
            set3.setDrawValues(drawvals[2]);
            set3.setValueTextSize(valtextsize[2]);
            set3.setValueTextColor(valcolor[2]);
            set3.setCircleColor(circlecolor[2]);       
            set3.setCircleSize(circlesize[2]);
            set3.setDrawCircleHole(circlehole[2]);
            MyValueFormatter mvf3 = new MyValueFormatter();
            mvf3.setNumberOfDigits(displayvaluedigits[2]);
            set3.setValueFormatter(mvf3);      
            if (drawcubic[2] == true) {
              set3.setDrawCubic(drawcubic[2]);
              set3.setCubicIntensity(cubicintensity[2]);
//            set3.setFillColor(fillcolor[2]);
            }
          }
          if (lineAxisDependency[2] == "RIGHT") set3.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[2] == "LEFT") set3.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set3);
          if (drawDashLine[2] == false) 
            sets.get(2).disableDashedLine(); 
        }


        if (numberOfCharts >= 4){
          LineDataSet set4 = new LineDataSet(yVals4, legendtext[3]);
          if (numberOfCharts >= 4){
            set4.enableDashedLine(10f, 10f, 0f);
            set4.setColor(linecolors[3]);
            set4.setDrawFilled(drawfilled[3]);
            if (drawfilled[3] == true)
                 set4.setFillColor(fillcolor[3]);
            set4.setLineWidth(graphlinewidth[3]);
            set4.setHighLightColor(linecolors[3]);                   //the color of the cross hair
            set4.setDrawValues(drawvals[3]);
            set4.setValueTextSize(valtextsize[3]);
            set4.setValueTextColor(valcolor[3]);
            set4.setCircleColor(circlecolor[3]);       
            set4.setCircleSize(circlesize[3]);
            set4.setDrawCircleHole(circlehole[3]);
            MyValueFormatter mvf4 = new MyValueFormatter();
            mvf4.setNumberOfDigits(displayvaluedigits[3]);
            set4.setValueFormatter(mvf4);      
            if (drawcubic[3] == true) {
              set4.setDrawCubic(drawcubic[3]);
              set4.setCubicIntensity(cubicintensity[3]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[3] == "RIGHT") set4.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[3] == "LEFT") set4.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set4);  
          if (drawDashLine[3] == false) 
            sets.get(3).disableDashedLine(); 
        }
		

        if (numberOfCharts >= 5){
          LineDataSet set5 = new LineDataSet(yVals5, legendtext[4]);
          if (numberOfCharts >= 5){
            set5.enableDashedLine(10f, 10f, 0f);
            set5.setColor(linecolors[4]);
            set5.setDrawFilled(drawfilled[4]);
            if (drawfilled[4] == true)
                 set5.setFillColor(fillcolor[4]);
            set5.setLineWidth(graphlinewidth[4]);
            set5.setHighLightColor(linecolors[4]);                   //the color of the cross hair
            set5.setDrawValues(drawvals[4]);
            set5.setValueTextSize(valtextsize[4]);
            set5.setValueTextColor(valcolor[4]);
            set5.setCircleColor(circlecolor[4]);       
            set5.setCircleSize(circlesize[4]);
            set5.setDrawCircleHole(circlehole[4]);
            MyValueFormatter mvf5 = new MyValueFormatter();
            mvf5.setNumberOfDigits(displayvaluedigits[4]);
            set5.setValueFormatter(mvf5);      
            if (drawcubic[4] == true) {
              set5.setDrawCubic(drawcubic[4]);
              set5.setCubicIntensity(cubicintensity[4]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[4] == "RIGHT") set5.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[4] == "LEFT") set5.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set5);  
          if (drawDashLine[4] == false) 
            sets.get(4).disableDashedLine(); 
        }		
		

        if (numberOfCharts >= 6){
          LineDataSet set6 = new LineDataSet(yVals6, legendtext[5]);
          if (numberOfCharts >= 6){
            set6.enableDashedLine(10f, 10f, 0f);
            set6.setColor(linecolors[5]);
            set6.setDrawFilled(drawfilled[5]);
            if (drawfilled[5] == true)
                 set6.setFillColor(fillcolor[5]);
            set6.setLineWidth(graphlinewidth[5]);
            set6.setHighLightColor(linecolors[5]);                   //the color of the cross hair
            set6.setDrawValues(drawvals[5]);
            set6.setValueTextSize(valtextsize[5]);
            set6.setValueTextColor(valcolor[5]);
            set6.setCircleColor(circlecolor[5]);       
            set6.setCircleSize(circlesize[5]);
            set6.setDrawCircleHole(circlehole[5]);
            MyValueFormatter mvf6 = new MyValueFormatter();
            mvf6.setNumberOfDigits(displayvaluedigits[5]);
            set6.setValueFormatter(mvf6);      
            if (drawcubic[5] == true) {
              set6.setDrawCubic(drawcubic[5]);
              set6.setCubicIntensity(cubicintensity[5]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[5] == "RIGHT") set6.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[5] == "LEFT") set6.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set6);  
          if (drawDashLine[5] == false) 
            sets.get(5).disableDashedLine(); 
        }	


        if (numberOfCharts >= 7){
          LineDataSet set7 = new LineDataSet(yVals7, legendtext[6]);
          if (numberOfCharts >= 7){
            set7.enableDashedLine(10f, 10f, 0f);
            set7.setColor(linecolors[6]);
            set7.setDrawFilled(drawfilled[6]);
            if (drawfilled[6] == true)
                 set7.setFillColor(fillcolor[6]);
            set7.setLineWidth(graphlinewidth[6]);
            set7.setHighLightColor(linecolors[6]);                   //the color of the cross hair
            set7.setDrawValues(drawvals[6]);
            set7.setValueTextSize(valtextsize[6]);
            set7.setValueTextColor(valcolor[6]);
            set7.setCircleColor(circlecolor[6]);       
            set7.setCircleSize(circlesize[6]);
            set7.setDrawCircleHole(circlehole[6]);
            MyValueFormatter mvf7 = new MyValueFormatter();
            mvf7.setNumberOfDigits(displayvaluedigits[6]);
            set7.setValueFormatter(mvf7);      
            if (drawcubic[6] == true) {
              set7.setDrawCubic(drawcubic[6]);
              set7.setCubicIntensity(cubicintensity[6]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[6] == "RIGHT") set7.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[6] == "LEFT") set7.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set7);  
          if (drawDashLine[6] == false) 
            sets.get(6).disableDashedLine(); 
        }						
		


        if (numberOfCharts >= 8){
          LineDataSet set8 = new LineDataSet(yVals8, legendtext[7]);
          if (numberOfCharts >= 8){
            set8.enableDashedLine(10f, 10f, 0f);
            set8.setColor(linecolors[7]);
            set8.setDrawFilled(drawfilled[7]);
            if (drawfilled[7] == true)
                 set8.setFillColor(fillcolor[7]);
            set8.setLineWidth(graphlinewidth[7]);
            set8.setHighLightColor(linecolors[7]);                   //the color of the cross hair
            set8.setDrawValues(drawvals[7]);
            set8.setValueTextSize(valtextsize[7]);
            set8.setValueTextColor(valcolor[7]);
            set8.setCircleColor(circlecolor[7]);       
            set8.setCircleSize(circlesize[7]);
            set8.setDrawCircleHole(circlehole[7]);
            MyValueFormatter mvf8 = new MyValueFormatter();
            mvf8.setNumberOfDigits(displayvaluedigits[7]);
            set8.setValueFormatter(mvf8);      
            if (drawcubic[7] == true) {
              set8.setDrawCubic(drawcubic[7]);
              set8.setCubicIntensity(cubicintensity[7]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[7] == "RIGHT") set8.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[7] == "LEFT") set8.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set8);  
          if (drawDashLine[7] == false) 
            sets.get(7).disableDashedLine(); 
        }	


        if (numberOfCharts >= 9){
          LineDataSet set9 = new LineDataSet(yVals9, legendtext[8]);
          if (numberOfCharts >= 9){
            set9.enableDashedLine(10f, 10f, 0f);
            set9.setColor(linecolors[8]);
            set9.setDrawFilled(drawfilled[8]);
            if (drawfilled[8] == true)
                 set9.setFillColor(fillcolor[8]);
            set9.setLineWidth(graphlinewidth[8]);
            set9.setHighLightColor(linecolors[8]);                   //the color of the cross hair
            set9.setDrawValues(drawvals[8]);
            set9.setValueTextSize(valtextsize[8]);
            set9.setValueTextColor(valcolor[8]);
            set9.setCircleColor(circlecolor[8]);       
            set9.setCircleSize(circlesize[8]);
            set9.setDrawCircleHole(circlehole[8]);
            MyValueFormatter mvf9 = new MyValueFormatter();
            mvf9.setNumberOfDigits(displayvaluedigits[8]);
            set9.setValueFormatter(mvf9);      
            if (drawcubic[8] == true) {
              set9.setDrawCubic(drawcubic[8]);
              set9.setCubicIntensity(cubicintensity[8]);
//            set4.setFillColor(fillcolor[3]);
            }
          }
          if (lineAxisDependency[8] == "RIGHT") set9.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[8] == "LEFT") set9.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set9);  
          if (drawDashLine[8] == false) 
            sets.get(8).disableDashedLine(); 
        }									
		


        if (numberOfCharts == 10){
          LineDataSet set10 = new LineDataSet(yVals10, legendtext[9]);
          if (numberOfCharts == 10){
            set10.enableDashedLine(10f, 10f, 0f);       
            set10.setColor(linecolors[9]);
            set10.setDrawFilled(drawfilled[9]);
            if (drawfilled[9] == true)
                 set10.setFillColor(fillcolor[9]);
            set10.setLineWidth(graphlinewidth[9]);
            set10.setHighLightColor(linecolors[9]);                   //the color of the cross hair
            set10.setDrawValues(drawvals[9]);
            set10.setValueTextSize(valtextsize[9]);
            set10.setValueTextColor(valcolor[9]);
            set10.setCircleColor(circlecolor[9]);       
            set10.setCircleSize(circlesize[9]);
            set10.setDrawCircleHole(circlehole[9]);
            MyValueFormatter mvf10 = new MyValueFormatter();
            mvf10.setNumberOfDigits(displayvaluedigits[9]);
            set10.setValueFormatter(mvf10);      
            if (drawcubic[9] == true) {
              set10.setDrawCubic(drawcubic[9]);
              set10.setCubicIntensity(cubicintensity[9]);
//            set5.setFillColor(fillcolor[9]);
            }
          }
          if (lineAxisDependency[9] == "RIGHT") set10.setAxisDependency(YAxis.AxisDependency.RIGHT);
          if (lineAxisDependency[9] == "LEFT") set10.setAxisDependency(YAxis.AxisDependency.LEFT);      
          sets.add(set10);
          if (drawDashLine[9] == false) 
            sets.get(9).disableDashedLine(); 
        }    
 

        LineData data = new LineData(xVals, sets);

        XAxis xAxis = cv.getXAxis();
//      xAxis.setTypeface(tf);
        xAxis.setTextSize(mXaxisTextSize);
        xAxis.setTextColor(mXaxisTextColor);
        xAxis.setDrawGridLines(mXaxisGridLines);
        xAxis.setDrawAxisLine(mXaxisLine);
        xAxis.setSpaceBetweenLabels(1);
        xAxis.setXaxisTextAngle(mAngle);
        xAxis.setGridColor(verticalgridcolor);
        if (mXaxisLabelsToSkip != 0) 
           xAxis.setLabelsToSkip(mXaxisLabelsToSkip);

        if (mXaxisLabelPosition.equals("TOP")) xAxis.setPosition(XAxisPosition.TOP);
        if (mXaxisLabelPosition.equals("BOTTOM")) xAxis.setPosition(XAxisPosition.BOTTOM);
        if (mXaxisLabelPosition.equals("BOTH_SIDED")) xAxis.setPosition(XAxisPosition.BOTH_SIDED);
        if (mXaxisLabelPosition.equals("TOP_INSIDE")) xAxis.setPosition(XAxisPosition.TOP_INSIDE);
        if (mXaxisLabelPosition.equals("BOTTOM_INSIDE")) xAxis.setPosition(XAxisPosition.BOTTOM_INSIDE);
 
        
        YAxis leftAxis = cv.getAxisLeft();
//      leftAxis.setTypeface(tf);
        leftAxis.setTextSize(mYaxisTextSize);
        leftAxis.setTextColor(mYaxisLeftTextColor);
        leftAxis.setDrawGridLines(mYaxisLeftGridLines);
        if (drawleftgriddashed == true)
          leftAxis.enableGridDashedLine(10.0f, 10.0f, 0.0f);

        leftAxis.setGridColor(horizontalgridcolorleft);
//        leftAxis.setAxisLineColor(0xff00ff00);

        leftAxis.setEnabled(leftlabels);
        leftAxis.setYaxisTextAngle(mYAngle);

//        BA.Log("" + yaxisLeftMinVal);
//        BA.Log("" + yaxisLeftMaxVal);

        if (yaxisLeftMinVal != 192837.0f){
          leftAxis.setAxisMinValue(yaxisLeftMinVal);
//        BA.Log("" + yaxisLeftMinVal);
        }
        if (yaxisLeftMaxVal != 192837.0f)
          leftAxis.setAxisMaxValue(yaxisLeftMaxVal);

//      BA.Log("setLabelCount = " + lyalc);
          if (lyalc != 0) 
            leftAxis.setLabelCount(lyalc, true);
//          BA.Log("setLabelCount = " + lyalc);
//        }

		MyValueFormatter lavf = new MyValueFormatter();
        lavf.setNumberOfDigits(YaxisLeftNumberOfDigits);
		leftAxis.setValueFormatter(lavf);

        leftAxis.setStartAtZero(lxsaz);

		

        
        YAxis rightAxis = cv.getAxisRight();
//      rightAxis.setTypeface(tf);
        rightAxis.setTextSize(mYaxisTextSize);
        rightAxis.setTextColor(mYaxisRightTextColor);
        rightAxis.setDrawGridLines(mYaxisRightGridLines);
        if (drawrightgriddashed == true)
          rightAxis.enableGridDashedLine(10.0f, 10.0f, 0.0f);

        rightAxis.setGridColor(horizontalgridcolorright);
//        rightAxis.setAxisLineColor(0xff00ff00);

//      rightAxis.setDrawGridLines(false);
//        if (yaxisMinVal !=192837.0)
//          rightAxis.setAxisMinValue(-100.0f);
//        if (yaxisMaxVal !=192837.0)
//          rightAxis.setAxisMaxValue(100.0f);
        rightAxis.setEnabled(rightlabels);
        rightAxis.setYaxisTextAngle(mYAngle);

        if (yaxisRightMinVal !=192837.0f)
          rightAxis.setAxisMinValue(yaxisRightMinVal);
        if (yaxisRightMaxVal !=192837.0f)
          rightAxis.setAxisMaxValue(yaxisRightMaxVal);

        if (ryalc != 0)
          rightAxis.setLabelCount(ryalc, true);

        rightAxis.setStartAtZero(rxsaz);

		MyValueFormatter ravf = new MyValueFormatter();
        ravf.setNumberOfDigits(YaxisRightNumberOfDigits);
		rightAxis.setValueFormatter(ravf);

        if (xyanimate == true)
           cv.animateXY(animationtime, animationtime);
        if (xanimate == true)
           cv.animateX(animationtime);
        if (yanimate == true)
           cv.animateY(animationtime);
        
        cv.setData(data);
    }


    /**
     *set the number of insignificant digits to appear in the graph values
     */
    public void setGraphValueDigits(int[] displayvaluedigits){
       this.displayvaluedigits = displayvaluedigits;
    }

     private int NoOfMarkerDigits = 0;
    /**
     *set the number of insignificant digits to appear in the markers
     */
     public void setNoOfMarkerDigits(int NoOfMarkerDigits){
        this.NoOfMarkerDigits = NoOfMarkerDigits;
     }


    /**
     *set the legend text colors to match their respective line colors
     */
     private boolean LegendTextColorsToMatchLineColors = false;
     public void setLegendTextColorsToMatchLineColors(boolean LegendTextColorsToMatchLineColors){
        this.LegendTextColorsToMatchLineColors = LegendTextColorsToMatchLineColors;
     }


    /**
     *Force the left y-axis to start at zero
     *mlc1.YaxisLeftStartAtZero = False ....(A)
     *mlc1.YaxisLeftMinVal = -1.0 ....(B)
     *mlc1.YaxisLeftMaxVal = 5.0 ....(C)	
     * 
     *If set to True then (B) will be ignored and the left y-axis will start at 0
     *If set to False then (B) and (C) will be adhered to
     *The default setting is False
     *If neither (A), (B), or (C) are used the scale will be set automatically
     */
    private boolean lxsaz = false;
    public void setYaxisLeftStartAtZero(boolean lxsaz) {
      this.lxsaz = lxsaz;
    }

    /**
     *Force the right y-axis to start at zero
     *mlc1.YaxisRightStartAtZero = False ....(A)
     *mlc1.YaxisRightMinVal = -1.0 ....(B)
     *mlc1.YaxisRightMaxVal = 5.0 ....(C)	
     * 
     *If set to True then (B) will be ignored and the right y-axis will start at 0
     *If set to False then (B) and (C) will be adhered to
     *The default setting is False
     *If neither (A), (B), or (C) are used the scale will be set automatically
     */
    private boolean rxsaz = false;
    public void setYaxisRightStartAtZero(boolean rxsaz) {
      this.rxsaz = rxsaz;
    }


    /**
     * Set wether Animation in X direction should be enable when drawing the charts
     */
    public void setXAnimate(boolean xa) {
        xanimate = xa;
    }

    /**
     * Set wether Animation in Y direction should be enable when drawing the charts
     */
    public void setYAnimate(boolean ya) {
        yanimate = ya;
    }

    /**
     * Set wether Animation in X and Y directions should be enable when drawing the charts
     */
    public void setXYAnimate(boolean xya) {
        xyanimate = xya;
    }

    /**
     * Set the chart drawing animation time
     */
    public void setChartAnimationTime(int at) {
        animationtime = at;
    }


    /**
     * Set the legend text color
     * This will be overridden if LegendTextColorsToMatchLineColors = True in
     * which case the legend text color will match the corresponding line color
     */
    public void setTheLegendColor(int lcolor) {
        l.setTextColor(lcolor);
    }

    /**
     * Set the legend text size
     */
    public void setTheLegendTextSize(float ltextsize) {
        l.setTextSize(ltextsize);
    }

    /**
     * Set the chart description / chart main title
     */
    public void setChartDescription(String descrip){
        cv.setDescription(descrip);
        cv.invalidate();
    }

    /**
     * Set the color of the chart description / main title
     */
    public void setChartDescriptionColor(int color){
        cv.setDescriptionColor(color);
        cv.invalidate();
    }

    /**
     * Set the text size of the chart description / main title
     */
    public void setChartDescriptionTextSize(float size) {
        cv.setDescriptionTextSize(size);
        cv.invalidate();
    }

    /**
     * Set the colors of the individual line charts
     * A maximum of 5 colors can be set (one for each of max 5 line charts)
     */
    public void setLineColors(int[] linecolor){
       linecolors = linecolor;
    }

    /**
     * Set the legend text for the individual line charts
     * A maximum of 5 legend texts can be set (one for each of max 5 line charts)
     */
    public void setLegendText(String[] ltext){
       legendtext = ltext;
    }

    /**
     * THIS WAS USED FOR SINGLE LINE CHART PROJECT
     */
    private void setChartData(float[] cdata){
       chartdata = cdata;
    }

    /**
     * Set the color of the values for each line chart
     * These are the values that are displayed inside the chart
     * when DrawGraphValues are set to true
     */
    public void setValueTextColor(int[] valuecolor){
      valcolor = valuecolor;
    }

    /**
     * Set the text size of the values for each line chart
     * These are the values that are displayed inside the chart
     * when DrawGraphValues are set to true
     */
    public void setValueTextSize(float[] vts){
      valtextsize = vts;
    }


    /**
     * THIS WAS USED FOR SINGLE LINE CHART PROJECT
     */
    private void setLegendTitle(String lt){
      legendtitle = lt;
    }
 
    /**
     * Clears this chart from all DataSets and removes all Entries. 
     * 
     */
    public void clearValues() {
        cv.clearValues();
        cv.invalidate();
    }


    /**
     * Sets the color for the background of the chart-drawing area (everything
     * behind the grid lines).
     * 
     */
    public void setGridBackgroundColor(int color) {
        cv.setGridBackgroundColor(color);
        cv.invalidate();
    }

    /**
     * Set this to true to enable dragging (moving the chart with the finger)
     * for the chart (this does not effect scaling).
     * 
     */
    public void setDragEnabled(boolean enabled) {
        cv.setDragEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable scaling (zooming in and out by gesture) for
     * the chart (this does not effect dragging) on both X- and Y-Axis.
     * 
     */
    public void setScaleEnabled(boolean enabled) {
        cv.setScaleEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable scaling (zooming in and out by gesture) for
     * the chart (this does not effect dragging) in X direction
     * 
     */
    public void setScaleXEnabled(boolean enabled) {
        cv.setScaleXEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable scaling (zooming in and out by gesture) for
     * the chart (this does not effect dragging) in Y direction
     * 
     */
    public void setScaleYEnabled(boolean enabled) {
        cv.setScaleYEnabled(enabled);
        cv.invalidate();
    }

    /**
     * Set this to true to enable zooming in by double-tap on the chart.
     * Default: enabled
     * 
     */
    public void setDoubleTapToZoomEnabled(boolean enabled) {
        cv.setDoubleTapToZoomEnabled(enabled);
        cv.invalidate();
    }

    /**
     * set this to true to draw the grid background, false if not
     * 
     */
    public void setDrawGridBackground(boolean enabled) {
        cv.setDrawGridBackground(enabled);
        cv.invalidate();
    }

    /**
     * Sets drawing the border to true or false. If this is enabled, there is
     * no point drawing the axis-lines of x- and y-axis.
     * 
     */
    public void setDrawBorders(boolean enabled) {
        cv.setDrawBorders(enabled);
        cv.invalidate();
    }

    /**
     * Sets the width of the border lines in dp.
     * 
     */
    public void setBorderWidth(float width) {
        cv.setBorderWidth(width);
        cv.invalidate();
    }

    /**
     * Sets the color of the chart border line.
     * 
     */
    public void setBorderColor(int color) {
        cv.setBorderColor(color);
        cv.invalidate();
    }


    /**
     * Sets a custom position for the description text in pixels on the screen.
     * 
     */
    public void setDescriptionPosition(float x, float y) {
        cv.setDescriptionPosition(x, y);
        cv.invalidate();
    }

    /**
     * Sets the description position to LEFT, RIGHT, CENTER.
     * 
     * @param x - xcoordinate
     * @param y - ycoordinate
     */
//    public void setDescriptionPosition(String pos) {
//        cv.setDescriptionPosition(pos);
//        cv.invalidate();
//    }

    /**
     * Set this to true to draw a user specified marker-view when tapping on
     * chart values (use the setMarkerView(MarkerView mv) method to specify a
     * marker view). Default: true
     *
     * @param enabled
     */
//    public void setDrawMarkerViews(boolean enabled) {
//        cv.setDrawMarkerViews(enabled);
//        cv.invalidate();
//    }

    /**
     * If set to true, value highlighting is enabled for all underlying data of
     * the chart which means that all values can be highlighted programmatically
     * or by touch gesture.
     *
     * @param enabled
     */
//    public void setHighlightEnabled(boolean enabled) {
//        cv.setHighlightEnabled(enabled);
//        cv.invalidate();
//    }

    /**
     * Sets extra offsets (around the chart view) to be appended to the
     * auto-calculated offsets.
     * 
     * @param left
     * @param top
     * @param right
     * @param bottom
     */
//    public void setExtraOffsets(float left, float top, float right, float bottom) {
//        cv.setExtraOffsets(left, top, right, bottom);
//        cv.invalidate();
//   }

    /**
     * Set an extra offset to be appended to the viewport's top
     */
//    public void setExtraTopOffset(float offset) {
//        cv.setExtraTopOffset(offset);
//        cv.invalidate();
//    }


    /**
     * Set an extra offset to be appended to the viewport's right
     */
//    public void setExtraRightOffset(float offset) {
//        cv.setExtraRightOffset(offset);
//        cv.invalidate();
//    }


    /**
     * Set an extra offset to be appended to the viewport's bottom
     */
//    public void setExtraBottomOffset(float offset) {
//        cv.setExtraBottomOffset(offset);
//        cv.invalidate();
//   }


    /**
     * Set an extra offset to be appended to the viewport's left
     */
//    public void setExtraLeftOffset(float offset) {
//        cv.setExtraLeftOffset(offset);
//        cv.invalidate();
//    }

    /**
     * disables intercept touchevents
     */
    public void disableScroll() {
        cv.disableScroll();
        cv.invalidate();
    }

    /**
     * enables intercept touchevents
     */
    public void enableScroll() {
        cv.enableScroll();
        cv.invalidate();
    }

    /**
     * set X-Axis text size
     */
    public void setXaxisTextSize(float size) {
        mXaxisTextSize = size;
        cv.invalidate();
    }    

    /**
     * set X-Axis text color
     */
    public void setXaxisTextColor(int xcolor) {
        mXaxisTextColor = xcolor;
        cv.invalidate();
    }    

    /**
     * set draw x-axis grid lines
     */
    public void setDrawXaxisGridLines(boolean dxagl) {
        mXaxisGridLines = dxagl;
        cv.invalidate();
    }    

    /**
     * set draw x-axis line
     */
    public void setDrawAxisLine(boolean dxal) {
        mXaxisLine = dxal;
        cv.invalidate();
    }    


    /**
     * set x-axis label position
     * XaxisLabelPosition can be one of the following:
     * TOP, BOTTOM, BOTH_SIDED, TOP_INSIDE, BOTTOM_INSIDE
     */
    public void setXaxisLabelPosition(String mXaxisLabelPosition){  
        this.mXaxisLabelPosition = mXaxisLabelPosition;
        cv.invalidate();
    }  

    /**
     * set Y-Axis text size
     */
    public void setYaxisTextSize(float size) {
        mYaxisTextSize = size;
        cv.invalidate();
    }    

    /**
     * set Y-Axis Left text color
     */
    public void setYaxisLeftTextColor(int ycolor) {
        mYaxisLeftTextColor = ycolor;
        cv.invalidate();
    }    

    /**
     * set Y-Axis Right text color
     */
    public void setYaxisRightTextColor(int ycolor) {
        mYaxisRightTextColor = ycolor;
        cv.invalidate();
    }    

    /**
     * set draw y-axis left grid lines
     */
    public void setDrawYaxisLeftGridLines(boolean dyagl) {
        mYaxisLeftGridLines = dyagl;
        cv.invalidate();
    }  

    /**
     * set draw y-axis right grid lines
     */
    public void setDrawYaxisRightGridLines(boolean dyagl) {
        mYaxisRightGridLines = dyagl;
        cv.invalidate();
    }  

    /**
     * Enable or Disable the line to be drawn in dashed mode.
     */
    public void setDrawDashedLine(boolean[] ddl) {
        drawDashLine = ddl;
        cv.invalidate();
    }


    /**
     * Set the color of the graph small circles.
     */
    public void setGraphCircleColor(int[] gcc) {
        circlecolor = gcc;
        cv.invalidate();
    }
  
    /**
     * Set the width of the graph lines.
     */
    public void setGraphLineWidth(float[] glw) {
        graphlinewidth = glw;
        cv.invalidate();
    }

    /**
     * Set the size of the graph small circles.
     */
    public void setGraphCircleSize(float[] gcs) {
        circlesize = gcs;
        cv.invalidate();
    }

    /**
     * Draw hollow or solid graph circles.
     */
    public void setDrawGraphHollowCircles(boolean[] ghc) {
        circlehole = ghc;
        cv.invalidate();
    }

    /**
     * Draw or don't draw values on the graph.
     */
    public void setDrawGraphValues(boolean[] dgv) {
        drawvals = dgv;
//      cv.invalidate();
    }

    /**
     * Draw or don't draw a cubic line graph.
     */
    public void setDrawCubicGraph(boolean[] dcg) {
        drawcubic = dcg;
        cv.invalidate();
    }

    /**
     * Set the intensity of the cubic line graph.
     * A value from 0.0 to 1.0
     */
    public void setCubicIntensity(float[] ci) {
        cubicintensity = ci;
        cv.invalidate();
    }


    /**
     * Set the color of the cross hair that appears
     * when the graph is touched
     */
//    public void setCrossHairColor(int cc) {
//        crosscolor = cc;
//        cv.invalidate();
//    }

    /**
     * Set the minimum value for the y axis (Left)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisLeftMinVal(float yamv) {
        yaxisLeftMinVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the maximum value for the y axis (Left)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisLeftMaxVal(float yamv) {
        yaxisLeftMaxVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the minimum value for the y axis (Right)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisRightMinVal(float yamv) {
        yaxisRightMinVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the maximum value for the y axis (Right)
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisRightMaxVal(float yamv) {
        yaxisRightMaxVal = yamv;
        cv.invalidate();
    }


    /**
     * Fill or don't fill the area between the line charts and the X axis.
     */
    public void setDrawFilled(boolean[] df) {
        drawfilled = df;
    }

    /**
     * Set the color to fill the area between the line charts and the X axis with.
     */
    public void setFillColor(int[] fc) {
        fillcolor = fc;
    }


    /**
     * Show or don't show the left Y-Axis labels.
     */
    public void setShowYaxisLeftLabels(boolean slyal) {
        leftlabels = slyal;
    }    

    /**
     * Show or don't show the right Y-Axis labels.
     */
    public void setShowYaxisRightLabels(boolean sryal) {
        rightlabels = sryal;
    }   

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
    public void setMarkerToUse(int mtu) {
        markertouse = mtu;
    }             

    /**
     * Set the X-Axis labels.
     */
    public void setXaxisLables(String[] xal) {
        xaxislabels = xal;
        cv.invalidate();
    } 

    /**
     * Set the data for line chart 1
     */
    public void setChart_1_Data(float[] c1d){
        chart_1_data = c1d;
        cv.invalidate();
    }

    /**
     * Set the data for line chart 2
     */
    public void setChart_2_Data(float[] c2d){
        chart_2_data = c2d;
        cv.invalidate();
    }

    /**
     * Set the data for line chart 3
     */
    public void setChart_3_Data(float[] c3d){
        chart_3_data = c3d;
        cv.invalidate();
    }

    /**
     * Set the data for line chart 4
     */
    public void setChart_4_Data(float[] c4d){
        chart_4_data = c4d;
        cv.invalidate();
    }

    /**
     * Set the data for line chart 5
     */
    public void setChart_5_Data(float[] c5d){
        chart_5_data = c5d;
        cv.invalidate();
    }
	
    /**
     * Set the data for line chart 6
     */
    public void setChart_6_Data(float[] c6d){
        chart_6_data = c6d;
        cv.invalidate();
    }
	
    /**
     * Set the data for line chart 7
     */
    public void setChart_7_Data(float[] c7d){
        chart_7_data = c7d;
        cv.invalidate();
    }	
	
    /**
     * Set the data for line chart 8
     */
    public void setChart_8_Data(float[] c8d){
        chart_8_data = c8d;
        cv.invalidate();
    }	
	
    /**
     * Set the data for line chart 9
     */
    public void setChart_9_Data(float[] c9d){
        chart_9_data = c9d;
        cv.invalidate();
    }	
	
    /**
     * Set the data for line chart 10
     */
    public void setChart_10_Data(float[] c10d){
        chart_10_data = c10d;
        cv.invalidate();
    }	

    /**
     * sets the space between the legend entries on a horizontal axis in pixels,
     * converts to dp internally
     * Default value is 6.0f
     */
    public void setLegendXEntrySpace(float space) {
         l.setXEntrySpace(space);
    }

    /**
     * sets the space between the legend entries on a vertical axis in pixels,
     * converts to dp internally
     * Default value is 10.0f
     */
    public void setLegendYEntrySpace(float space) {
         l.setYEntrySpace(space);
    }


    /**
     * Sets the angle to rotate the X-axis labels by
     * Suggest rotation of between -30.0 and 30.0 where 0.0 will be no rotation (i.e text horizontal)
     */
    public void setXaxisTextAngle(float angle){
        mAngle = angle;
    }

    /**
     * Sets the angle to rotate the Y-axis labels by
     * Suggest rotation of between -30.0 and 30.0 where 0.0 will be no rotation (i.e text horizontal)
     */
    public void setYaxisTextAngle(float angle){
        mYAngle = angle;
    }

    /**
     * Sets the Y axis dependancy
     * Pass an array of strings (maximum 5) of "LEFT"'s and "RIGHT"'s
     */
    public void setYaxisDependancy(String[] yad){
        lineAxisDependency = yad;
    }

    /**
     * Sets the Vertical grid color
     */
    public void setVerticalGridColor(int vgc){
        verticalgridcolor = vgc;
    }

    /**
     * Sets the Horizontal grid color for the Left Y axis
     */
    public void setHorizontalGridColorLeft(int hgcl){
        horizontalgridcolorleft = hgcl;
    }

    /**
     * Sets the Horizontal grid color for the Right Y axis
     */
    public void setHorizontalGridColorRight(int hgcr){
        horizontalgridcolorright = hgcr;
    }


    /**
     * Sets the Left Y axis grid to be drawn dashed or solid
     */
    public void setDrawLeftGridDashed(boolean dlgd){
        drawleftgriddashed = dlgd;
    }

    /**
     * Sets the Right Y axis grid to be drawn dashed or solid
     */
    public void setDrawRightGridDashed(boolean drgd){
        drawrightgriddashed = drgd;
    }


//    private int lyalc = 0;
    /**
     * Set the label count for the left Y Axis
     */
    public void setYaxisLeftLabelCount(int mlyalc){
        lyalc = mlyalc;
    }

//    private int ryalc = 0;
    /**
     * Set the label count for the right Y Axis
     */
    public void setYaxisRightLabelCount(int mryalc){
        ryalc = mryalc;
    }


    /**
     * Sets the number of labels that should be skipped on the axis before the
     * next label is drawn. This will disable the feature that automatically
     * calculates an adequate space between the axis labels and set the number
     * of labels to be skipped to the fixed number provided by this method. 
     * 
     */
    public void setXaxisLabelsToSkip(int sxalts) {
        mXaxisLabelsToSkip = sxalts;
    }



    /**
     * Calling this will disable a custom number of labels to be skipped (set by
     * setLabelsToSkip(...)) while drawing the x-axis. Instead, the number of
     * values to skip will again be calculated automatically.
     */
//    public void resetXaxisLabelsToSkip(rxal) {
//        mIsAxisModulusCustom = false;
//    }


     /**
     * Set the number of digits to display after the decimal point for the Left Y-axis
     */
      private int YaxisLeftNumberOfDigits = 1;
      public void setYaxisLeftNumberOfDigits(int YaxisLeftNumberOfDigits) {
		  this.YaxisLeftNumberOfDigits = YaxisLeftNumberOfDigits;
	  }
	  

     /**
     * Set the number of digits to display after the decimal point for the Right Y-axis
     */
      private int YaxisRightNumberOfDigits = 1;
      public void setYaxisRightNumberOfDigits(int YaxisRightNumberOfDigits) {
		  this.YaxisRightNumberOfDigits = YaxisRightNumberOfDigits;
	  }	  






    /**
     * Saves the current state of the chart to the gallery as a JPEG image. The
     * filename and compression can be set. 0 == maximum compression, 100 = low
     * compression (high quality). NOTE: Needs permission WRITE_EXTERNAL_STORAGE
     *
     * fileName e.g. "my_image"
     * quality e.g. 50, min = 0, max = 100
     */
       public void saveToGallery(String fileName, int quality) {
            cv.saveToGallery(fileName, quality);
       }


    /**
     * Saves the current chart state with the given name to the given path on
     * the sdcard leaving the path empty "" will put the saved file directly on
     * the SD card chart is saved as a PNG image, example:
     * saveToPath("myfilename", "foldername1/foldername2");
     *
     * fileName e.g. "my_image"
     * pathOnSD e.g. "folder1/folder2/folder3"
     */
    public void saveToPath(String fileName, String pathOnSD) {
      cv.saveToPath(fileName, pathOnSD);
    }

    /**
     * Returns the bitmap that represents the chart.
     *
     * @return
     */
    public Bitmap getChartBitmap() {
        Bitmap image = cv.getChartBitmap(); 
//        byte[] byteArray = cv.getChartBitmap();
//        image = BitmapFactory.decodeByteArray(byteArray, 0, byteArray.length);     //added by johan schoeman
        BitmapWrapper bw = new BitmapWrapper();                                    //added by johan schoeman - Erel advised
        bw.setObject(image); 
        return image;
    }


    /**
     * Set the outer zone color for the chart being saved
     *
     */
    public void setSavedImageBackgroundColor(int color){
       cv.setSavedImageBackgroundColor(color);
    }

    @Override
    public void onValueSelected(Entry e, int dataSetIndex, Highlight h) {
		
		if (ba.subExists(eventName + "_value_selected")) {
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_value_selected", true, new Object[] {e.getXIndex(), e.getVal()});
		}		
		//BA.Log("Value selected " + e.getVal());
		//BA.Log("Index of delected " + e.getXIndex());
        //Log.i("Entry selected", e.toString());
    }

	@Override
    public void onNothingSelected() {
        //Log.i("Nothing selected", "Nothing selected.");
    }

}
