package mpandroidchartwrapper;

import com.github.mikephil.charting.charts.PieChart;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;
import android.graphics.Color;


import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.graphics.Typeface;

import java.util.ArrayList;

import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.Legend.LegendPosition;
import com.github.mikephil.charting.components.Legend.LegendForm;
import com.github.mikephil.charting.components.Legend.LegendDirection;
import com.github.mikephil.charting.data.DataSet;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.PieData;
import com.github.mikephil.charting.data.PieDataSet;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.PercentFormatter;
import com.github.mikephil.charting.components.ComponentBase;
import com.github.mikephil.charting.components.MyMarkerView;
import com.github.mikephil.charting.components.R;
import com.github.mikephil.charting.listener.PieRadarChartTouchListener;
import com.github.mikephil.charting.listener.OnChartGestureListener;



@Author("Johan Schoeman")
@Events(values={"value_selected(index As Int, value As Float)", "long_pressed()"})
//@Version(1.00f)
@ShortName("PieChart")
public class pieChartWrapper extends ViewWrapper<PieChart> implements DesignerCustomView, OnChartValueSelectedListener, OnChartGestureListener  {

        private Typeface tf;
        private Legend l;
        private ComponentBase cb;

	private BA ba;
	private String eventName;
        private PieChart cv;
        private int[] piecolors;
        private String[] legendtext;
        private float[] chartdata;
        private int valcolor = 0xffff0000;
        private float valtextsize = 12.0f;
        private String legendtitle = "";
        @Hide
        public static boolean usepercentval = true;
        private int markertouse = 4; 
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new PieChart(ba.context);
        this.setObject(cv);
		cv.setOnChartValueSelectedListener(this);
		cv.setOnChartGestureListener(this);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}





    public void setPieData(int count) {
        count = count - 1;
//        float mult = range;

        ArrayList<Entry> yVals1 = new ArrayList<Entry>();

        // IMPORTANT: In a PieChart, no values (Entry) should have the same
        // xIndex (even if from different DataSets), since no values can be
        // drawn above each other.
        for (int i = 0; i < count+1; i++) {
//            yVals1.add(chartdata[i]);
            yVals1.add(new Entry((float) chartdata[i], i));



        }

        ArrayList<String> xVals = new ArrayList<String>();

//        String[] mParties = {"A111", "B111", "C111", "D111", "E111", "F111"};

        for (int i = 0; i < count+1; i++)
            xVals.add(legendtext[i]);

        if (markertouse == 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }
        if (markertouse == 3) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_3);
          cv.setMarkerView(mv);
        }
        if (markertouse == 2) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_2);
          cv.setMarkerView(mv);
        }
        if (markertouse == 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_1);
          cv.setMarkerView(mv);
        }
        if (markertouse > 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }
        if (markertouse < 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          cv.setMarkerView(mv);
        }

        PieDataSet dataSet = new PieDataSet(yVals1, legendtitle);
        dataSet.setSliceSpace(1f);
        dataSet.setSelectionShift(10f);

        // add a lot of colors

        ArrayList<Integer> colors = new ArrayList<Integer>();
        for (int i = 0; i < count+1 ; i++) {
           colors.add(piecolors[i]);
        }

//        for (int c : ColorTemplate.VORDIPLOM_COLORS)
//            colors.add(c);

//        for (int c : ColorTemplate.JOYFUL_COLORS)
//            colors.add(c);

//        for (int c : ColorTemplate.COLORFUL_COLORS)
//            colors.add(c);

//        for (int c : ColorTemplate.LIBERTY_COLORS)
//            colors.add(c);

//        for (int c : ColorTemplate.PASTEL_COLORS)
//            colors.add(c);

//        colors.add(ColorTemplate.getHoloBlue());

        dataSet.setColors(colors);

        PieData data = new PieData(xVals, dataSet);
        data.setValueFormatter(new PercentFormatter());
        data.setValueTextSize(valtextsize);
        data.setValueTextColor(valcolor);
        data.setValueTypeface(tf);
        cv.setData(data);

        // undo all highlights
        cv.highlightValues(null);

        cv.invalidate();
    }






    /**
     * Sets the color for the hole that is drawn in the center of the PieChart
     * (if enabled). NOTE: Use setHoleColorTransparent(boolean enabled) to make
     * the hole transparent.
     * 
     * @param color
     */
    public void setHoleColor(int color) {
        cv.setHoleColor(color);
        cv.invalidate();
    }

    /**
     * Set the hole in the center of the PieChart transparent. Thank you, code
     * provided by:
     * 
     * @link https://github.com/tbarthel-fr
     * @param enable
     */
    public void setHoleColorTransparent(boolean enable) {
        cv.setHoleColorTransparent(enable);
        cv.invalidate();
    }

    /**
     * Returns true if the hole in the center of the PieChart is transparent,
     * false if not.
     *
     * @return true if hole is transparent.
     */
    public boolean isHoleTransparent() {
        return cv.isHoleTransparent();
    }

    /**
     * set this to true to draw the pie center empty
     * 
     * @param enabled
     */
    public void setDrawHoleEnabled(boolean enabled) {
        cv.setDrawHoleEnabled(enabled);
        cv.invalidate();
    }

    /**
     * returns true if the hole in the center of the pie-chart is set to be
     * visible, false if not
     * 
     * @return
     */
    public boolean isDrawHoleEnabled() {
        return cv.isDrawHoleEnabled();
    }

    /**
     * sets the text that is displayed in the center of the pie-chart. By
     * default, the text is "Total Value + sumofallvalues"
     * 
     * @param text
     */
    public void setCenterText(String text) {
        cv.setCenterText(text);
        cv.invalidate();
    }

    /**
     * returns the text that is drawn in the center of the pie-chart
     * 
     * @return
     */
    public String getCenterText() {
        return cv.getCenterText();
    }

    /**
     * set this to true to draw the text that is displayed in the center of the
     * pie chart
     * 
     * @param enabled
     */
    public void setDrawCenterText(boolean enabled) {
        cv.setDrawCenterText(enabled);
        cv.invalidate();
    }

    /**
     * returns true if drawing the center text is enabled
     * 
     * @return
     */
    public boolean isDrawCenterTextEnabled() {
        return cv.isDrawCenterTextEnabled();
    }

    /**
     * sets the typeface for the center-text paint
     * 
     * @param t
     */
//    public void setCenterTextTypeface(Typeface t) {
//        cv.setCenterTextTypeface(t);
//        cv.invalidate();
//    }

    /**
     * Sets the size of the center text of the PieChart in dp.
     * 
     * @param size
     */
    public void setCenterTextSize(float sizeDp) {
        cv.setCenterTextSize(sizeDp);
        cv.invalidate();
    }

    /**
     * Sets the size of the center text of the PieChart in pixels.
     * 
     * @param size
     */
    public void setCenterTextSizePixels(float sizePixels) {
        cv.setCenterTextSizePixels(sizePixels);
        cv.invalidate();
    }

    /**
     * Sets the color of the center text of the PieChart.
     * 
     * @param color
     */
    public void setCenterTextColor(int color) {
        cv.setCenterTextColor(color);
        cv.invalidate();
    }

    /**
     * sets the radius of the hole in the center of the piechart in percent of
     * the maximum radius (max = the radius of the whole chart), default 50%
     * 
     * @param size
     */
    public void setHoleRadius(final float percent) {
        cv.setHoleRadius(percent);
        cv.invalidate();
    }

    /**
     * Returns the size of the hole radius in percent of the total radius.
     * 
     * @return
     */
    public float getHoleRadius() {
        return cv.getHoleRadius();
    }

    /**
     * Sets the color the transparent-circle should have.
     * @param color
     */
    public void setTransparentCircleColor(int color) {
        cv.setTransparentCircleColor(color);
        cv.invalidate();
    }

    /**
     * sets the radius of the transparent circle that is drawn next to the hole
     * in the piechart in percent of the maximum radius (max = the radius of the
     * whole chart), default 55% -> means 5% larger than the center-hole by
     * default
     * 
     * @param percent
     */
    public void setTransparentCircleRadius(final float percent) {
        cv.setTransparentCircleRadius(percent);
        cv.invalidate();
    }

    public float getTransparentCircleRadius() {
        return cv.getTransparentCircleRadius();
    }

	/**
	 * Sets the amount of transparency the transparent circle should have 0 = fully transparent, 255 = fully opaque.
     * Default value is 100.
	 * 
	 * @param alpha
	 *            0-255
	 */
	public void setTransparentCircleAlpha(int alpha) {
		cv.setTransparentCircleAlpha(alpha);
                cv.invalidate();
	}

    /**
     * set this to true to draw the x-value text into the pie slices
     * 
     * @param enabled
     */
    public void setDrawSliceText(boolean enabled) {
        cv.setDrawSliceText(enabled);
        cv.invalidate();
    }

    /**
     * returns true if drawing x-values is enabled, false if not
     * 
     * @return
     */
    public boolean isDrawSliceTextEnabled() {
        return cv.isDrawSliceTextEnabled();
    }

    /**
     * Returns true if the chart is set to draw each end of a pie-slice
     * "rounded".
     * 
     * @return
     */
    public boolean isDrawRoundedSlicesEnabled() {
        return cv.isDrawRoundedSlicesEnabled();
    }

    /**
     * If this is enabled, values inside the PieChart are drawn in percent and
     * not with their original value. Values provided for the ValueFormatter to
     * format are then provided in percent.
     * 
     * @param enabled
     */
    public void setUsePercentValues(boolean enabled) {
        cv.setUsePercentValues(enabled);
        usepercentval = enabled;
        cv.invalidate();
    }

    /**
     * Returns true if using percentage values is enabled for the chart.
     * 
     * @return
     */
    public boolean isUsePercentValuesEnabled() {
        return cv.isUsePercentValuesEnabled();
    }

    /**
     * should the center text be word wrapped?
     * note that word wrapping takes a toll on performance
     * if word wrapping is disabled, newlines are still respected
     */
    public void setCenterTextWordWrapEnabled(boolean enabled) {
        cv.setCenterTextWordWrapEnabled(enabled);
        cv.invalidate();
    }

    /**
     * should the center text be word wrapped?
     * note that word wrapping takes a toll on performance
     * if word wrapping is disabled, newlines are still respected
     */
    public boolean isCenterTextWordWrapEnabled() {
        return cv.isCenterTextWordWrapEnabled();
    }

    /**
     * the rectangular radius of the bounding box for the center text, as a percentage of the pie hole
     * default 1.f (100%)
     */
    public void setCenterTextRadiusPercent(float percent) {
        cv.setCenterTextRadiusPercent(percent);
        cv.invalidate();
    }

    /**
     * the rectangular radius of the bounding box for the center text, as a percentage of the pie hole
     * default 1.f (100%)
     */
    public float getCenterTextRadiusPercent() {
        return cv.getCenterTextRadiusPercent();
    }


    public void setTheLegendPosition(String legendpos) {
        l = cv.getLegend();
          if (legendpos == "RIGHT_OF_CHART")
                l.setPosition(LegendPosition.RIGHT_OF_CHART);
          if (legendpos == "RIGHT_OF_CHART_CENTER")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_CENTER);
          if (legendpos == "RIGHT_OF_CHART_INSIDE")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_INSIDE);
          if (legendpos == "LEFT_OF_CHART")       
                l.setPosition(LegendPosition.LEFT_OF_CHART);
          if (legendpos == "LEFT_OF_CHART_CENTER")       
                l.setPosition(LegendPosition.LEFT_OF_CHART_CENTER);
          if (legendpos == "LEFT_OF_CHART_INSIDE")        
                l.setPosition(LegendPosition.LEFT_OF_CHART_INSIDE);
          if (legendpos == "BELOW_CHART_LEFT")        
                l.setPosition(LegendPosition.BELOW_CHART_LEFT);
          if (legendpos == "BELOW_CHART_RIGHT")        
                l.setPosition(LegendPosition.BELOW_CHART_RIGHT);
          if (legendpos == "BELOW_CHART_CENTER")        
                l.setPosition(LegendPosition.BELOW_CHART_CENTER);
          if (legendpos == "PIECHART_CENTER")
                l.setPosition(LegendPosition.PIECHART_CENTER);

        l.setXEntrySpace(7f);
        l.setYEntrySpace(0f);
        l.setYOffset(0f);
    }


//    public void setTheLegendForm(String legendform) {
//        l = cv.getForm();
//          if (legendform == "SQUARE")
//                l.setForm(LegendForm.SQUARE);
//          if (legendform == "CIRCLE")
//                l.setForm(LegendForm.CIRCLE);
//          if (legendform == "LINE")
//                l.setForm(LegendForm.LINE);
//        l.setXEntrySpace(7f);
//        l.setYEntrySpace(0f);
//        l.setYOffset(0f);
//    }



//    public enum LegendForm {
//        SQUARE, CIRCLE, LINE
//    }

//    public enum LegendDirection {
//        LEFT_TO_RIGHT, RIGHT_TO_LEFT
//    }




    public void setTheLegendColor(int lcolor) {
        l.setTextColor(lcolor);
    }

    public void setTheLegendTextSize(float ltextsize) {
        l.setTextSize(ltextsize);
    }

    public void setChartDescription(String descrip){
        cv.setDescription(descrip);
        cv.invalidate();
    }

    public void setChartDescriptionColor(int color){
        cv.setDescriptionColor(color);
        cv.invalidate();
    }

    public void setChartDescriptionTextSize(float size) {
        cv.setDescriptionTextSize(size);
        cv.invalidate();
    }

    public void setPieColors(int[] piecolor){
       piecolors = piecolor;
    }

    public void setLegendText(String[] ltext){
       legendtext = ltext;
    }

    public void setChartData(float[] cdata){
       chartdata = cdata;
    }

    public void setValueTextColor(int valuecolor){
      valcolor = valuecolor;
    }

    public void setValueTextSize(int vts){
      valtextsize = vts;
    }

    public void setLegendTitle(String lt){
      legendtitle = lt;
    }
 
    /**
     * Clears this data object from all DataSets and removes all Entries. Don't
     * forget to invalidate the chart after this.
     */
    public void clearValues() {
        cv.clearValues();
        cv.invalidate();
    }

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
//    public void setMarkerToUse(int mtu) {
//        markertouse = mtu;
//    }   



    /**
     * Saves the current state of the chart to the gallery as a JPEG image. The
     * filename and compression can be set. 0 == maximum compression, 100 = low
     * compression (high quality). NOTE: Needs permission WRITE_EXTERNAL_STORAGE
     *
     * fileName e.g. "my_image"
     * quality e.g. 50, min = 0, max = 100
     */
       public void saveToGallery(String fileName, int quality) {
            cv.saveToGallery(fileName, quality);
       }


    /**
     * Saves the current chart state with the given name to the given path on
     * the sdcard leaving the path empty "" will put the saved file directly on
     * the SD card chart is saved as a PNG image, example:
     * saveToPath("myfilename", "foldername1/foldername2");
     *
     * fileName e.g. "my_image"
     * pathOnSD e.g. "folder1/folder2/folder3"
     */
    public void saveToPath(String fileName, String pathOnSD) {
      cv.saveToPath(fileName, pathOnSD);
    }

    /**
     * Returns the bitmap that represents the chart.
     *
     * @return
     */
    public Bitmap getChartBitmap() {
        Bitmap image = cv.getChartBitmap(); 
//        byte[] byteArray = cv.getChartBitmap();
//        image = BitmapFactory.decodeByteArray(byteArray, 0, byteArray.length);     //added by johan schoeman
        BitmapWrapper bw = new BitmapWrapper();                                    //added by johan schoeman - Erel advised
        bw.setObject(image); 
        return image;
    }

    public void setSavedImageBackgroundColor(int color){
       cv.setSavedImageBackgroundColor(color);
    }  

    public void setRotationEnabled(boolean enabled) {
        cv.setRotationEnabled(enabled);
        cv.invalidate();
    } 

    @Override
    public void onValueSelected(Entry e, int dataSetIndex, Highlight h) {
		
		if (ba.subExists(eventName + "_value_selected")) {
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_value_selected", true, new Object[] {e.getXIndex(), e.getVal()});
		}		
		//BA.Log("Value selected " + e.getVal());
		//BA.Log("Index of delected " + e.getXIndex());
        //Log.i("Entry selected", e.toString());
    }

	@Override
    public void onNothingSelected() {
        //Log.i("Nothing selected", "Nothing selected.");
    }	
	
	
    /**
     * Callbacks when the chart is longpressed.
     * 
     * @param me
     */
	@Override
    public void onChartLongPressed(MotionEvent me) {
		
		if (ba.subExists(eventName + "_long_pressed")) {
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_long_pressed", true, new Object[0]);
		}				
		
	}	
	
	@Override
    public void onChartDoubleTapped(MotionEvent me) {
		
	}	

    /**
     * Callbacks when the chart is single-tapped.
     * 
     * @param me
     */
	@Override 
    public void onChartSingleTapped(MotionEvent me) {
		
	}

    /**
     * Callbacks then a fling gesture is made on the chart.
     * 
     * @param me1
     * @param me2
     * @param velocityX
     * @param velocityY
     */
	@Override
    public void onChartFling(MotionEvent me1, MotionEvent me2, float velocityX, float velocityY) {
		
	}

    /**
     * Callbacks when the chart is scaled / zoomed via pinch zoom gesture.
     * 
     * @param me
     * @param scaleX scalefactor on the x-axis
     * @param scaleY scalefactor on the y-axis
     */
	@Override 
    public void onChartScale(MotionEvent me, float scaleX, float scaleY) {
		
	}

	/**
	 * Callbacks when the chart is moved / translated via drag gesture.
	 *
	 * @param me
	 * @param dX translation distance on the x-axis
	 * @param dY translation distance on the y-axis
	 */
	@Override 
	public void onChartTranslate(MotionEvent me, float dX, float dY) {
		
	}



}
