package mpandroidchartwrapper;

import com.github.mikephil.charting.charts.RadarChart;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;
import android.graphics.Color;


import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.graphics.Typeface;

import java.util.ArrayList;

import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.Legend.LegendPosition;
import com.github.mikephil.charting.components.Legend.LegendForm;
import com.github.mikephil.charting.components.Legend.LegendDirection;
import com.github.mikephil.charting.data.DataSet;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.RadarData;
import com.github.mikephil.charting.data.RadarDataSet;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.PercentFormatter;
import com.github.mikephil.charting.components.ComponentBase;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.components.MyMarkerView;
import com.github.mikephil.charting.components.R;
import com.github.mikephil.charting.utils.MyValueFormatter;


@Author("Johan Schoeman")
@Events(values={"value_selected(index As Int, value As Float)"})
//@Version(1.00f)
@ShortName("RadarChart")
public class radarChartWrapper extends ViewWrapper<RadarChart> implements DesignerCustomView, OnChartValueSelectedListener  {

        private Typeface tf;
        private Legend l;
        private ComponentBase cb;

	private BA ba;
	private String eventName;
        private RadarChart cv;
//      private int[] radarcolors;
//        private float[] chartdata;
        private int valcolor = 0xffff0000;
        private float valtextsize = 12.0f;
        private String[] legendtext = null;
        private int crosscolor = 0xffff0000;
        private float yaxisMinVal = 192837.0f;
        private float yaxisMaxVal = 192837.0f;       
        private float mXaxisTextSize = 12.0f;
        private int mXaxisTextColor = Color.BLUE;
        private float mYaxisTextSize = 15.0f;
        private int mYaxisTextColor = Color.BLUE;
        private boolean drawvals = true;
        private boolean drawfilled = false;  
        private int[] graphcolor = null;
        private float graphlinewidth = 2.0f;
        private float shapesize = 15.0f;
        private String[] xaxislabels = null;

        private float[] chart_1_data = null;
        private float[] chart_2_data = null;
        private float[] chart_3_data = null;
        private float[] chart_4_data = null;
        private float[] chart_5_data = null; 
        private boolean drawweb = true;
        private int concentriccolor = 0xff0000ff;
        private int radialcolor = 0xffff0000;
        private float radiallinewidth = 1.5f;
        private float concentriclinewidth = 0.75f;
        private int webalpha = 100;
        private int markertouse = 4; 
        private boolean xanimate = false;
        private boolean yanimate = true;
        private boolean xyanimate = false;
        private int animationtime = 0;
        private int[] displayvaluedigits = {0, 0, 0, 0, 0};		
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new RadarChart(ba.context);
        this.setObject(cv);
		cv.setOnChartValueSelectedListener(this);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

//    public void setXAnimate(boolean xa) {
//        xanimate = xa;
//    }

//    public void setYAnimate(boolean ya) {
//        yanimate = ya;
//    }

//    public void setXYAnimate(boolean xya) {
//        xyanimate = xya;
//    }


    public void setChartAnimationTime(int at) {
        animationtime = at;
    }


    public void setRadarData(int numberOfCharts, int numberOfEntriesPerChart) {
//        float mult = 600;


        ArrayList<Entry> yVals1 = new ArrayList<Entry>();
        ArrayList<Entry> yVals2 = new ArrayList<Entry>();
        ArrayList<Entry> yVals3 = new ArrayList<Entry>();
        ArrayList<Entry> yVals4 = new ArrayList<Entry>();
        ArrayList<Entry> yVals5 = new ArrayList<Entry>();

          
        if (numberOfCharts >= 1){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals1.add(new Entry(chart_1_data[i], i));
          }
        }

        if (numberOfCharts >= 2){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals2.add(new Entry(chart_2_data[i], i));
          }
        }

        if (numberOfCharts >= 3){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals3.add(new Entry(chart_3_data[i], i));
          }
        }

        if (numberOfCharts >= 4){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals4.add(new Entry(chart_4_data[i], i));
          }
        }

        if (numberOfCharts == 5){
          for (int i = 0; i < numberOfEntriesPerChart; i++) {
              yVals5.add(new Entry(chart_5_data[i], i));
          }
        }

        ArrayList<String> xVals = new ArrayList<String>();

        for (int i = 0; i < numberOfEntriesPerChart; i++)
            xVals.add(xaxislabels[i]);


        if (markertouse == 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 3) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_3);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 2) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_2);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse == 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_1);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse > 4) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }
        if (markertouse < 1) {
          MyMarkerView mv = new MyMarkerView(ba.context, R.layout.custom_marker_view_4);
          mv.setNumberOfDigits(NoOfMarkerDigits);
          cv.setMarkerView(mv);
        }


        RadarDataSet set1 = new RadarDataSet(yVals1, legendtext[0]);
        if (numberOfCharts >= 1){
        set1.setColor(graphcolor[0]);
        set1.setDrawFilled(drawfilled);
        set1.setLineWidth(graphlinewidth);
        set1.setHighLightColor(graphcolor[0]);                   //the color of the cross hair
        set1.setDrawValues(drawvals);
        MyValueFormatter mvf1 = new MyValueFormatter();
        mvf1.setNumberOfDigits(displayvaluedigits[0]);
        set1.setValueFormatter(mvf1);     		
        }


        RadarDataSet set2 = new RadarDataSet(yVals2, legendtext[1]);
        if (numberOfCharts >= 2){
        set2.setColor(graphcolor[1]);
        set2.setDrawFilled(drawfilled);
        set2.setLineWidth(graphlinewidth);
        set2.setHighLightColor(graphcolor[1]);                   //the color of the cross hair
        set2.setDrawValues(drawvals);
        MyValueFormatter mvf2 = new MyValueFormatter();
        mvf2.setNumberOfDigits(displayvaluedigits[1]);
        set2.setValueFormatter(mvf2);     				
        }


        RadarDataSet set3 = new RadarDataSet(yVals3, legendtext[2]);
        if (numberOfCharts >= 3){
        set3.setColor(graphcolor[2]);
        set3.setDrawFilled(drawfilled);
        set3.setLineWidth(graphlinewidth);
        set3.setHighLightColor(graphcolor[2]);                   //the color of the cross hair
        set3.setDrawValues(drawvals);
        MyValueFormatter mvf3 = new MyValueFormatter();
        mvf3.setNumberOfDigits(displayvaluedigits[2]);
        set3.setValueFormatter(mvf3);    		
        }


        RadarDataSet set4 = new RadarDataSet(yVals4, legendtext[3]);
        if (numberOfCharts >= 4){
        set4.setColor(graphcolor[3]);
        set4.setDrawFilled(drawfilled);
        set4.setLineWidth(graphlinewidth);
        set4.setHighLightColor(graphcolor[3]);                   //the color of the cross hair
        set4.setDrawValues(drawvals);
        MyValueFormatter mvf4 = new MyValueFormatter();
        mvf4.setNumberOfDigits(displayvaluedigits[3]);
        set4.setValueFormatter(mvf4);  		
        }


        RadarDataSet set5 = new RadarDataSet(yVals5, legendtext[4]);
        if (numberOfCharts == 5){
        set5.setColor(graphcolor[4]);
        set5.setDrawFilled(drawfilled);
        set5.setLineWidth(graphlinewidth);
        set5.setHighLightColor(graphcolor[4]);                   //the color of the cross hair
        set5.setDrawValues(drawvals);
        MyValueFormatter mvf5 = new MyValueFormatter();
        mvf5.setNumberOfDigits(displayvaluedigits[4]);
        set5.setValueFormatter(mvf5);  			
        }

        ArrayList<RadarDataSet> sets = new ArrayList<RadarDataSet>();
        sets.add(set1);
        sets.add(set2);
        sets.add(set3);
        sets.add(set4);
        sets.add(set5);

        RadarData data = new RadarData(xVals, sets);
        data.setValueTextSize(valtextsize);
        data.setValueTextColor(valcolor);
        
        data.setDrawValues(drawvals);
        
        cv.setDrawWeb(drawweb);
        cv.setWebColorInner(concentriccolor);
        cv.setWebColor(radialcolor);
        cv.setWebLineWidth(radiallinewidth);
        cv.setWebLineWidthInner(concentriclinewidth);
        cv.setWebAlpha(webalpha);

        cv.setRotationEnabled(true);

        XAxis xAxis = cv.getXAxis();
//      xAxis.setTypeface(tf);
        xAxis.setTextSize(mXaxisTextSize);
        xAxis.setTextColor(mXaxisTextColor);

        YAxis yAxis = cv.getYAxis();
//      yAxis.setTypeface(tf);
//      yAxis.setLabelCount(5, false);
        yAxis.setTextSize(mYaxisTextSize);
        yAxis.setTextColor(mYaxisTextColor);
        yAxis.setStartAtZero(true);
        if (yaxisMinVal !=192837.0)
          yAxis.setAxisMinValue(yaxisMinVal);
        if (yaxisMaxVal !=192837.0)
          yAxis.setAxisMaxValue(yaxisMaxVal);
	  
		MyValueFormatter lavf = new MyValueFormatter();
        lavf.setNumberOfDigits(YaxisNumberOfDigits);
		yAxis.setValueFormatter(lavf);	  

//        if (xyanimate == true)
//           cv.animateXY(animationtime, animationtime);
//        if (xanimate == true)
//           cv.animateX(animationtime);
//        if (yanimate == true)
//           cv.animateY(animationtime);

        cv.setData(data);
    }
	
	
     /**
     * Set the number of digits to display after the decimal point for the Left Y-axis
     */
      private int YaxisNumberOfDigits = 1;
      public void setYaxisNumberOfDigits(int YaxisNumberOfDigits) {
		  this.YaxisNumberOfDigits = YaxisNumberOfDigits;
	  }	
	
	
     private int NoOfMarkerDigits = 0;
    /**
     *set the number of insignificant digits to appear in the markers
     */
     public void setNoOfMarkerDigits(int NoOfMarkerDigits){
        this.NoOfMarkerDigits = NoOfMarkerDigits;
     }	
	 
    /**
     *set the number of insignificant digits to appear in the graph values
     */
    public void setGraphValueDigits(int[] displayvaluedigits){
       this.displayvaluedigits = displayvaluedigits;
    }	 
	 
    /**
     * show or don't show the legend
     */
      public void setLegendVisible(boolean legendvisible){
           l.setEnabled(legendvisible);
           cv.invalidate();
      }      
	  
	  
	 
	 
	 

    public void setTheLegendPositionAndForm(String legendpos, String legendform) {
        l = cv.getLegend();
          if (legendpos == "RIGHT_OF_CHART")
                l.setPosition(LegendPosition.RIGHT_OF_CHART);
          if (legendpos == "RIGHT_OF_CHART_CENTER")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_CENTER);
          if (legendpos == "RIGHT_OF_CHART_INSIDE")
                l.setPosition(LegendPosition.RIGHT_OF_CHART_INSIDE);
          if (legendpos == "LEFT_OF_CHART")       
                l.setPosition(LegendPosition.LEFT_OF_CHART);
          if (legendpos == "LEFT_OF_CHART_CENTER")       
                l.setPosition(LegendPosition.LEFT_OF_CHART_CENTER);
          if (legendpos == "LEFT_OF_CHART_INSIDE")        
                l.setPosition(LegendPosition.LEFT_OF_CHART_INSIDE);
          if (legendpos == "BELOW_CHART_LEFT")        
                l.setPosition(LegendPosition.BELOW_CHART_LEFT);
          if (legendpos == "BELOW_CHART_RIGHT")        
                l.setPosition(LegendPosition.BELOW_CHART_RIGHT);
          if (legendpos == "BELOW_CHART_CENTER")        
                l.setPosition(LegendPosition.BELOW_CHART_CENTER);

          if (legendform == "SQUARE") 
            l.setForm(LegendForm.SQUARE);
          if (legendform == "CIRCLE") 
            l.setForm(LegendForm.CIRCLE);
          if (legendform == "LINE") 
            l.setForm(LegendForm.LINE);

          l.setFormSize(shapesize);
//          l.setXEntrySpace(7f);

//          l.setYEntrySpace(5f);
    }


    public void setLegendShapeSize(float fsize){
         shapesize = fsize;
         cv.invalidate();
    }

    public void setTheLegendColor(int lcolor) {
        l.setTextColor(lcolor);
    }

    public void setTheLegendTextSize(float ltextsize) {
        l.setTextSize(ltextsize);
    }

    public void setChartDescription(String descrip){
        cv.setDescription(descrip);
        cv.invalidate();
    }

    public void setChartDescriptionColor(int color){
        cv.setDescriptionColor(color);
        cv.invalidate();
    }

    public void setChartDescriptionTextSize(float size) {
        cv.setDescriptionTextSize(size);
        cv.invalidate();
    }

//    public void setRadarColors(int[] radarcolor){
//       radarcolors = radarcolor;
//    }


//    public void setChartData(float[] cdata){
//       chartdata = cdata;
//    }

    public void setValueTextColor(int valuecolor){
      valcolor = valuecolor;
    }

    public void setValueTextSize(int vts){
      valtextsize = vts;
    }

    public void setLegendText(String[] lt){
      legendtext = lt;
    }
 
    /**
     * Clears this data object from all DataSets and removes all Entries. Don't
     * forget to invalidate the chart after this.
     */
    public void clearValues() {
        cv.clearValues();
        cv.invalidate();
    }






    /**
     * Set the color of the cross hair that appears
     * when the graph is touched
     */
    public void setCrossHairColor(int cc) {
        crosscolor = cc;
        cv.invalidate();
    }

    /**
     * Set the minimum value for the y axis
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisMinVal(float yamv) {
        yaxisMinVal = yamv;
        cv.invalidate();
    }

    /**
     * Set the maximum value for the y axis
     * If a value is not set then it will be calculated automatically
     */
    public void setYaxisMaxVal(float yamv) {
        yaxisMaxVal = yamv;
        cv.invalidate();
    }

    /**
     * set X-Axis text size
     */
    public void setXaxisTextSize(float size) {
        mXaxisTextSize = size;
        cv.invalidate();
    }    

    /**
     * set X-Axis text color
     */
    public void setXaxisTextColor(int xcolor) {
        mXaxisTextColor = xcolor;
        cv.invalidate();
    }  

    /**
     * set Y-Axis text size
     */
    public void setYaxisTextSize(float size) {
        mYaxisTextSize = size;
        cv.invalidate();
    }    

    /**
     * set Y-Axis text color
     */
    public void setYaxisTextColor(int ycolor) {
        mYaxisTextColor = ycolor;
        cv.invalidate();
    } 

    /**
     * Draw or don't draw values on the graph.
     */
    public void setDrawGraphValues(boolean dgv) {
        drawvals = dgv;
        cv.invalidate();
    } 

    /**
     * Fill or don't fill the area between the graph and the X axis.
     */
    public void setDrawFilled(boolean df) {
        drawfilled = df;
        cv.invalidate();
    }

    /**
     * Set the color to fill the area between the graph and the X axis with.
     */
//    public void setFillColor(int fc) {
//        fillcolor = fc;
//        cv.invalidate();
//    } 

    public void setGraphLineColor(int[] glc) {
        graphcolor = glc;
        cv.invalidate();
    }

  
    /**
     * Set the width of the graph line.
     */
    public void setGraphLineWidth(float glw) {
        graphlinewidth = glw;
        cv.invalidate();
    } 

    /**
     * Set the X-Axis labels.
     */
    public void setXaxisLables(String[] xal) {
        xaxislabels = xal;
        cv.invalidate();
    } 

    public void setChart_1_Data(float[] c1d){
        chart_1_data = c1d;
        cv.invalidate();
    }

    public void setChart_2_Data(float[] c2d){
        chart_2_data = c2d;
        cv.invalidate();
    }

    public void setChart_3_Data(float[] c3d){
        chart_3_data = c3d;
        cv.invalidate();
    }

    public void setChart_4_Data(float[] c4d){
        chart_4_data = c4d;
        cv.invalidate();
    }

    public void setChart_5_Data(float[] c5d){
        chart_5_data = c5d;
        cv.invalidate();
    }

    public void setDrawWeb(boolean dw){
        drawweb = dw;
    }

    public void setWebConcentricColor(int wcc){
        concentriccolor = wcc;
    }

    public void setWebRadialColor(int wrc){
        radialcolor = wrc;
    }

    public void setRadialLineWidth(float rlw){
        radiallinewidth = rlw;
    }

    public void setConcentricLineWidth(float clw){
        concentriclinewidth = clw;
    }

    public void setWebAlpha(int wa){
        webalpha = wa;
    }

    /**
     * Set the marker (image)to be used.
     * An int value from 1 to 4
     * See the res/drawable and res/layout folders of the B4A project
     */
    public void setMarkerToUse(int mtu) {
        markertouse = mtu;
    }   




    /**
     * Saves the current state of the chart to the gallery as a JPEG image. The
     * filename and compression can be set. 0 == maximum compression, 100 = low
     * compression (high quality). NOTE: Needs permission WRITE_EXTERNAL_STORAGE
     *
     * fileName e.g. "my_image"
     * quality e.g. 50, min = 0, max = 100
     */
       public void saveToGallery(String fileName, int quality) {
            cv.saveToGallery(fileName, quality);
       }


    /**
     * Saves the current chart state with the given name to the given path on
     * the sdcard leaving the path empty "" will put the saved file directly on
     * the SD card chart is saved as a PNG image, example:
     * saveToPath("myfilename", "foldername1/foldername2");
     *
     * fileName e.g. "my_image"
     * pathOnSD e.g. "folder1/folder2/folder3"
     */
    public void saveToPath(String fileName, String pathOnSD) {
      cv.saveToPath(fileName, pathOnSD);
    }

    /**
     * Returns the bitmap that represents the chart.
     *
     * @return
     */
    public Bitmap getChartBitmap() {
        Bitmap image = cv.getChartBitmap(); 
//        byte[] byteArray = cv.getChartBitmap();
//        image = BitmapFactory.decodeByteArray(byteArray, 0, byteArray.length);     //added by johan schoeman
        BitmapWrapper bw = new BitmapWrapper();                                    //added by johan schoeman - Erel advised
        bw.setObject(image); 
        return image;
    }

    public void setSavedImageBackgroundColor(int color){
       cv.setSavedImageBackgroundColor(color);
    }    

    public void setRotationEnabled(boolean enabled) {
        cv.setRotationEnabled(enabled);
        cv.invalidate();
    }              

    @Override
    public void onValueSelected(Entry e, int dataSetIndex, Highlight h) {
		
		if (ba.subExists(eventName + "_value_selected")) {
		  ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_value_selected", true, new Object[] {e.getXIndex(), e.getVal()});
		}		
		//BA.Log("Value selected " + e.getVal());
		//BA.Log("Index of delected " + e.getXIndex());
        //Log.i("Entry selected", e.toString());
    }

	@Override
    public void onNothingSelected() {
        //Log.i("Nothing selected", "Nothing selected.");
    }	

}
